// Code generated by running "go generate" in golang.org/x/text. DO NOT EDIT.

package main

import (
	"golang.org/x/text/language"
	"golang.org/x/text/message"
	"golang.org/x/text/message/catalog"
)

type dictionary struct {
	index []uint32
	data  string
}

func (d *dictionary) Lookup(key string) (data string, ok bool) {
	p, ok := messageKeyToIndex[key]
	if !ok {
		return "", false
	}
	start, end := d.index[p], d.index[p+1]
	if start == end {
		return "", false
	}
	return d.data[start:end], true
}

func init() {
	dict := map[string]catalog.Dictionary{
		"de":    &dictionary{index: deIndex, data: deData},
		"en":    &dictionary{index: enIndex, data: enData},
		"fa":    &dictionary{index: faIndex, data: faData},
		"fr":    &dictionary{index: frIndex, data: frData},
		"id":    &dictionary{index: idIndex, data: idData},
		"it":    &dictionary{index: itIndex, data: itData},
		"ja":    &dictionary{index: jaIndex, data: jaData},
		"pl":    &dictionary{index: plIndex, data: plData},
		"ro":    &dictionary{index: roIndex, data: roData},
		"ru":    &dictionary{index: ruIndex, data: ruData},
		"sk":    &dictionary{index: skIndex, data: skData},
		"sl":    &dictionary{index: slIndex, data: slData},
		"vi":    &dictionary{index: viIndex, data: viData},
		"zh_CN": &dictionary{index: zh_CNIndex, data: zh_CNData},
		"zh_TW": &dictionary{index: zh_TWIndex, data: zh_TWData},
	}
	fallback := language.MustParse("en")
	cat, err := catalog.NewFromMap(dict, catalog.Fallback(fallback))
	if err != nil {
		panic(err)
	}
	message.DefaultCatalog = cat
}

var messageKeyToIndex = map[string]int{
	"%.2f\u00a0GiB":                         21,
	"%.2f\u00a0KiB":                         19,
	"%.2f\u00a0MiB":                         20,
	"%.2f\u00a0TiB":                         22,
	"%d day(s)":                             13,
	"%d hour(s)":                            14,
	"%d minute(s)":                          15,
	"%d second(s)":                          16,
	"%d tunnels were unable to be removed.": 158,
	"%d year(s)":                            12,
	"%d\u00a0B":                             18,
	"%s\n\nPlease consult the log for more information.": 111,
	"%s (out of date)":                        112,
	"%s (unsigned build, no updates)":         163,
	"%s You cannot undo this action.":         154,
	"%s ago":                                  17,
	"%s received, %s sent":                    71,
	"%s: %q":                                  23,
	"&About WireGuard…":                       109,
	"&Activate":                               58,
	"&Block untunneled traffic (kill-switch)": 82,
	"&Configuration:":                         86,
	"&Copy":                                   102,
	"&Deactivate":                             57,
	"&Edit":                                   133,
	"&Import tunnel(s) from file…":            119,
	"&Manage tunnels…":                        118,
	"&Name:":                                  79,
	"&Public key:":                            80,
	"&Remove selected tunnel(s)":              141,
	"&Save":                                   84,
	"&Save to file…":                          104,
	"&Toggle":                                 138,
	"(no argument): elevate and install manager service": 1,
	"(unknown)":                             81,
	"A name is required.":                   88,
	"A tunnel was unable to be removed: %s": 156,
	"About WireGuard":                       51,
	"Activating":                            97,
	"Active":                                96,
	"Add &empty tunnel…":                    134,
	"Add Tunnel":                            135,
	"Addresses:":                            62,
	"Addresses: %s":                         124,
	"Addresses: None":                       117,
	"All peers must have public keys":       44,
	"Allowed IPs:":                          65,
	"An Update is Available!":               129,
	"An interface must have a private key":  42,
	"An update to WireGuard is available. It is highly advisable to update without delay.":            166,
	"An update to WireGuard is now available. You are advised to update as soon as possible.":         131,
	"Another tunnel already exists with the name ‘%s’":                                                144,
	"Another tunnel already exists with the name ‘%s’.":                                               92,
	"App version: %s\nGo backend version: %s\nGo version: %s\nOperating system: %s\nArchitecture: %s": 53,
	"Are you sure you would like to delete %d tunnels?":                                               151,
	"Are you sure you would like to delete tunnel ‘%s’?":                                              153,
	"Brackets must contain an IPv6 address":                                                           28,
	"Cancel":                                                                                          85,
	"Close":                                                                                           54,
	"Command Line Options":                                                                            3,
	"Config key is missing an equals separator":                                                       38,
	"Configuration Files (*.zip, *.conf)|*.zip;*.conf|All Files (*.*)|*.*":                            159,
	"Configuration ZIP Files (*.zip)|*.zip":                                                           161,
	"Could not enumerate existing tunnels: %v":                                                        143,
	"Could not import selected configuration: %v":                                                     142,
	"Create new tunnel":                                                                               77,
	"DNS servers:":                                                                                    63,
	"Deactivating":                                                                                    99,
	"Delete %d tunnels":                                                                               150,
	"Delete tunnel ‘%s’":                                                                              152,
	"E&xit":                                                                                           120,
	"Edit &selected tunnel…":                                                                          140,
	"Edit tunnel":                                                                                     78,
	"Endpoint:":                                                                                       66,
	"Error":                                                                                           0,
	"Error Exiting WireGuard":                                                                         164,
	"Error in getting configuration":                                                                  45,
	"Error: %v. Please try again.":                                                                    170,
	"Export all tunnels to &zip…":                                                                     139,
	"Export all tunnels to zip":                                                                       137,
	"Export log to file":                                                                              108,
	"Export tunnels to zip":                                                                           162,
	"Failed to activate tunnel":                                                                       73,
	"Failed to deactivate tunnel":                                                                     74,
	"Failed to determine tunnel state":                                                                72,
	"File ‘%s’ already exists.\n\nDo you want to overwrite it?":                                       95,
	"Import tunnel(s) from file":                                                                      160,
	"Imported %d of %d tunnels":                                                                       148,
	"Imported %d tunnels":                                                                             147,
	"Imported tunnels":                                                                                146,
	"Inactive":                                                                                        98,
	"Interface: %s":                                                                                   75,
	"Invalid IP address":                                                                              24,
	"Invalid MTU":                                                                                     29,
	"Invalid endpoint host":                                                                           27,
	"Invalid key for [Interface] section":                                                             40,
	"Invalid key for [Peer] section":                                                                  41,
	"Invalid key for interface section":                                                               46,
	"Invalid key for peer section":                                                                    48,
	"Invalid key: %v":                                                                                 32,
	"Invalid name":                                                                                    87,
	"Invalid network prefix length":                                                                   25,
	"Invalid persistent keepalive":                                                                    31,
	"Invalid port":                                                                                    30,
	"Key must have a value":                                                                           39,
	"Keys must decode to exactly 32 bytes":                                                            33,
	"Latest handshake:":                                                                               68,
	"Line must occur in a section":                                                                    37,
	"Listen port:":                                                                                    60,
	"Log":                                                                                             101,
	"Log message":                                                                                     106,
	"MTU:":                                                                                            61,
	"Missing port from endpoint":                                                                      26,
	"Now":                                                                                             10,
	"Number must be a number between 0 and 2^64-1: %v":                                                34,
	"Peer":                                76,
	"Persistent keepalive:":               67,
	"Preshared key:":                      64,
	"Protocol version must be 1":          47,
	"Public key:":                         59,
	"Remove selected tunnel(s)":           136,
	"Select &all":                         103,
	"Status:":                             56,
	"Status: %s":                          123,
	"Status: Complete!":                   171,
	"Status: Unknown":                     116,
	"Status: Waiting for updater service": 169,
	"Status: Waiting for user":            167,
	"System clock wound backward!":        11,
	"Text Files (*.txt)|*.txt|All Files (*.*)|*.*": 107,
	"The %s tunnel has been activated.":            126,
	"The %s tunnel has been deactivated.":          128,
	"Time":                                         105,
	"Transfer:":                                    69,
	"Tunnel Error":                                 110,
	"Tunnel already exists":                        91,
	"Tunnel name is not valid":                     36,
	"Tunnel name ‘%s’ is invalid.":                 89,
	"Tunnels":                                      132,
	"Two commas in a row":                          35,
	"Unable to create new configuration":           93,
	"Unable to create tunnel":                      149,
	"Unable to delete tunnel":                      155,
	"Unable to delete tunnels":                     157,
	"Unable to determine whether the process is running under WOW64: %v":                          4,
	"Unable to exit service due to: %v. You may want to stop WireGuard from the service manager.": 165,
	"Unable to import configuration: %v":                                                          145,
	"Unable to list existing tunnels":                                                             90,
	"Unable to open current process token: %v":                                                    6,
	"Unable to wait for WireGuard window to appear: %v":                                           114,
	"Unknown state":    100,
	"Update Now":       168,
	"Usage: %s [\n%s]": 2,
	"When a configuration has exactly one peer, and that peer has an allowed IPs containing at least one of 0.0.0.0/0 or ::/0, then the tunnel service engages a firewall ruleset to block all traffic that is neither to nor from the tunnel interface, with special exceptions for DHCP and NDP.": 83,
	"WireGuard Activated":        125,
	"WireGuard Deactivated":      127,
	"WireGuard Detection Error":  113,
	"WireGuard Tunnel Error":     121,
	"WireGuard Update Available": 130,
	"WireGuard is running, but the UI is only accessible from desktops of the Builtin %s group.": 8,
	"WireGuard logo image": 52,
	"WireGuard may only be used by users who are a member of the Builtin %s group.": 7,
	"WireGuard system tray icon did not appear after 30 seconds.":                   9,
	"WireGuard: %s":          122,
	"WireGuard: Deactivated": 115,
	"Writing file failed":    94,
	"You must use the 64-bit version of WireGuard on this computer.": 5,
	"[EnumerationSeparator]": 49,
	"[UnitSeparator]":        50,
	"[none specified]":       43,
	"enabled":                70,
	"http2: Framer %p: failed to decode just-written frame": 172,
	"http2: Framer %p: read %v":                             174,
	"http2: Framer %p: wrote %v":                            173,
	"http2: decoded hpack field %+v":                        175,
	"♥ &Donate!":                                            55,
}

var deIndex = []uint32{ // 177 elements
	// Entry 0 - 1F
	0x00000000, 0x00000007, 0x00000059, 0x00000074,
	0x0000008b, 0x000000e1, 0x0000012d, 0x00000161,
	0x000001b8, 0x00000230, 0x00000280, 0x00000286,
	0x000002ac, 0x000002cc, 0x000002ea, 0x0000030e,
	0x00000332, 0x00000358, 0x00000362, 0x0000036b,
	0x00000378, 0x00000385, 0x00000392, 0x0000039f,
	0x000003ac, 0x000003c2, 0x000003ea, 0x00000408,
	0x00000422, 0x00000456, 0x00000465, 0x00000476,
	// Entry 20 - 3F
	0x00000496, 0x000004b4, 0x000004eb, 0x00000517,
	0x00000533, 0x00000550, 0x00000581, 0x000005bc,
	0x000005da, 0x00000608, 0x00000630, 0x0000066a,
	0x0000067f, 0x000006bd, 0x000006e3, 0x00000710,
	0x00000731, 0x00000759, 0x0000075c, 0x0000075f,
	0x0000076f, 0x0000077e, 0x000007e6, 0x000007f1,
	0x000007ff, 0x00000807, 0x00000815, 0x00000821,
	0x0000083b, 0x00000849, 0x0000084e, 0x00000858,
	// Entry 40 - 5F
	0x00000864, 0x0000087a, 0x00000888, 0x00000892,
	0x000008a7, 0x000008c1, 0x000008ce, 0x000008d8,
	0x000008f8, 0x00000923, 0x00000948, 0x0000096f,
	0x00000984, 0x0000098f, 0x000009ac, 0x000009be,
	0x000009c5, 0x000009e0, 0x000009ec, 0x00000a20,
	0x00000b4e, 0x00000b59, 0x00000b63, 0x00000b73,
	0x00000b84, 0x00000b9c, 0x00000bc0, 0x00000bf3,
	0x00000c0c, 0x00000c44, 0x00000c72, 0x00000c92,
	// Entry 60 - 7F
	0x00000cd7, 0x00000cdd, 0x00000ce7, 0x00000cef,
	0x00000cfb, 0x00000d0f, 0x00000d19, 0x00000d23,
	0x00000d34, 0x00000d4b, 0x00000d50, 0x00000d61,
	0x00000d92, 0x00000db0, 0x00000dc4, 0x00000dd2,
	0x00000e13, 0x00000e24, 0x00000e3f, 0x00000e87,
	0x00000e9e, 0x00000eb0, 0x00000ec0, 0x00000ed5,
	0x00000ef6, 0x00000eff, 0x00000f17, 0x00000f28,
	0x00000f36, 0x00000f46, 0x00000f5a, 0x00000f7c,
	// Entry 80 - 9F
	0x00000f92, 0x00000fb6, 0x00000fda, 0x00000ffe,
	0x00001071, 0x00001078, 0x00001084, 0x000010a8,
	0x000010bb, 0x000010d9, 0x00001103, 0x0000110f,
	0x00001134, 0x00001158, 0x00001179, 0x000011ba,
	0x000011ec, 0x00001226, 0x0000125a, 0x0000126c,
	0x000012a5, 0x000012f1, 0x00001311, 0x00001346,
	0x000013b6, 0x000013d2, 0x00001409, 0x00001446,
	0x00001465, 0x00001495, 0x000014bb, 0x0000151c,
	// Entry A0 - BF
	0x00001566, 0x00001582, 0x000015ab, 0x000015ca,
	0x000015f5, 0x00001617, 0x00001683, 0x000016f1,
	0x0000170b, 0x0000171f, 0x00001748, 0x00001776,
	0x00001786, 0x000017d2, 0x000017f9, 0x0000181c,
	0x0000183f,
} // Size: 732 bytes

const deData string = "" + // Size: 6207 bytes
	"\x02Fehler\x02(kein Argument): Als Administrator ausführen und den Manag" +
	"er-Dienst installieren\x02Verwendung: %[1]s [\x0a%[2]s]\x02Kommandozeile" +
	"noptionen\x02Es kann nicht festgestellt werden, ob der Prozess unter WOW" +
	"64 ausgeführt wird: %[1]v\x02Sie müssen die 64-Bit-Version von WireGuard" +
	" auf diesem Computer verwenden.\x02Konnte aktuellen Prozess-Token nicht " +
	"öffnen: %[1]v\x02WireGuard kann nur von Benutzern verwendet werden, die" +
	" Mitglied der Gruppe %[1]s sind.\x02WireGuard wird ausgeführt, aber auf " +
	"die Benutzeroberfläche kann nur von Desktops der Gruppe %[1]s zugegriffe" +
	"n werden.\x02Das WireGuard-Taskleistensymbol ist nicht innerhalb von 30 " +
	"Sekunden erschienen.\x02Jetzt\x02Die Systemuhr wurde zurück gestellt!" +
	"\x14\x01\x81\x01\x00\x02\x0b\x02%[1]d Jahr\x00\x0c\x02%[1]d Jahre\x14" +
	"\x01\x81\x01\x00\x02\x0a\x02%[1]d Tag\x00\x0b\x02%[1]d Tage\x14\x01\x81" +
	"\x01\x00\x02\x0d\x02%[1]d Stunde\x00\x0e\x02%[1]d Stunden\x14\x01\x81" +
	"\x01\x00\x02\x0d\x02%[1]d Minute\x00\x0e\x02%[1]d Minuten\x14\x01\x81" +
	"\x01\x00\x02\x0e\x02%[1]d Sekunde\x00\x0f\x02%[1]d Sekunden\x02vor %[1]s" +
	"\x02%[1]d\u00a0B\x02%.2[1]f\u00a0KiB\x02%.2[1]f\u00a0MiB\x02%.2[1]f" +
	"\u00a0GiB\x02%.2[1]f\u00a0TiB\x02%[1]s: %[2]q\x02Ungültige IP-Adresse" +
	"\x02Ungültige Länge des Netzwerkpräfixes\x02Fehlender Port des Endpunkte" +
	"s\x02Ungültiger Endpunkt-Host\x02Eckige Klammern müssen eine IPv6 Adress" +
	"e enthalten\x02Ungültige MTU\x02Ungültiger Port\x02Ungültiges Erhaltungs" +
	"intervall\x02Ungültiger Schlüssel: %[1]v\x02Schlüssel müssen auf exakt 3" +
	"2 Bytes dekodiert werden\x02Zahl muss zwischen 0 und 2^64-1 sein: %[1]v" +
	"\x02Zwei Kommata in einer Zeile\x02Der Tunnelname ist ungültig\x02Die Ze" +
	"ile muss innerhalb eines Abschnitts stehen\x02Konfigurationsschlüssel fe" +
	"hlt ein Gleichheitstrennzeichen\x02Eintrag muss einen Wert haben\x02Ungü" +
	"ltiger Eintrage im [Interface] Abschnitt\x02Ungültiger Eintrag im [Peer]" +
	" Abschnitt\x02Eine Schnittstelle muss einen privaten Schlssel enthalten" +
	"\x02[nicht spezifiziert]\x02Alle Teilnehmer (peers) müssen öffentliche S" +
	"chlüssel haben\x02Fehler beim Abrufen der Konfiguration\x02Ungültiger Ei" +
	"ntrag im Abschnitt [interface]\x02Die Protokollversion muss 1 sein\x02Un" +
	"gültiger Eintrag im Abschnitt [peer]\x02, \x02, \x02Über WireGuard\x02Wi" +
	"reGuard Logo\x02App Version: %[1]s\x0aGo Backend Version: %[2]s\x0aGo Ve" +
	"rsion: %[3]s\x0aBetriebssystem: %[4]s\x0aArchitektur: %[5]s\x02Schließen" +
	"\x02♥ &Spenden!\x02Status:\x02&Deaktivieren\x02&Aktivieren\x02Öffentlich" +
	"er Schlüssel:\x02Eingangsport:\x02MTU:\x02Adressen:\x02DNS-Server:\x02Ge" +
	"teilter Schlüssel:\x02Erlaubte IPs:\x02Endpunkt:\x02Erhaltungsintervall:" +
	"\x02Letzter Schlüsseltausch:\x02Übertragen:\x02aktiviert\x02%[1]s empfan" +
	"gen, %[1]s gesendet\x02Tunnelstatus konnte nicht ermittelt werden\x02Tun" +
	"nel aktivieren ist fehlgeschlagen\x02Tunnel deaktivieren ist fehlgeschla" +
	"gen\x02Schnittstelle: %[1]s\x02Teilnehmer\x02Einen neuen Tunnel erstelle" +
	"n\x02Tunnel bearbeiten\x02&Name:\x02&Öffentlicher Schlüssel:\x02(unbekan" +
	"nt)\x02&Blockiere Verkehr außerhalb des Tunnels (Not-Aus)\x02Wenn die Ko" +
	"nfiguration genau einen Teilnehmer enthält und dieser einen der Einträge" +
	" 0.0.0.0/0 oder ::/0 in den Erlaubten IPs enthält, so wird ein Firewall-" +
	"Regelsatz erstellt, der allen Verkehr blockiert, der weder aus dem Tunne" +
	"l stammt noch in diesen geht, mit Ausnahmen für DHCP- und NDP-Verkehr." +
	"\x02&Speichern\x02Abbrechen\x02&Konfiguration:\x02Ungültiger Name\x02Ein" +
	" Name ist notwendig.\x02Der Name „%[1]s“ ist ungültig.\x02Vorhandene Tun" +
	"nel können nicht aufgelistet werden\x02Tunnel existiert bereits\x02Ein T" +
	"unnel mit dem Namen „%[1]s“ existiert bereits.\x02Neue Konfiguration kan" +
	"n nicht erstellt werden\x02Schreiben der Datei schlug fehl\x02Die Datei " +
	"„%[1]s“ existiert bereits.\x0a\x0aMöchten Sie sie ersetzen?\x02Aktiv" +
	"\x02Aktiviere\x02Inaktiv\x02Deaktiviere\x02Unbekannter Zustand\x02Protok" +
	"oll\x02&Kopieren\x02&Alles markieren\x02&In Datei Speichern…\x02Zeit\x02" +
	"Protokolleintrag\x02Textdateien (*.txt)|*.txt|Alle Dateien (*.*)|*.*\x02" +
	"Exportiere Protokoll in Datei\x02&Über WireGuard…\x02Tunnel Fehler\x02%[" +
	"1]s\x0a\x0aBitte lesen Sie das Protokoll für weitere Informationen.\x02%" +
	"[1]s (veraltet)\x02WireGuard Erkennungsfehler\x02Warten auf das Erschein" +
	"en des WireGuard Fensters nicht möglich: %[1]v \x02WireGuard: Deaktivier" +
	"t\x02Status: Unbekannt\x02Adressen: Keine\x02Tunnel &verwalten…\x02Tunne" +
	"l aus Datei &importieren…\x02&Beenden\x02WireGuard Tunnel Fehler\x02Wire" +
	"Guard: %[1]s\x02Status: %[1]s\x02Adressen: %[1]s\x02WireGuard aktiviert" +
	"\x02Der Tunnel %[1]s wurde aktiviert.\x02WireGuard deaktiviert\x02Der Tu" +
	"nnel %[1]s wurde deaktiviert.\x02Eine Aktualisierung ist verfügbar!\x02W" +
	"ireGuard Aktualisierung verfügbar\x02Eine Aktualisierung für WireGuard i" +
	"st jetzt verfügbar. Es wird empfohlen diese schnellstmöglich durchzuführ" +
	"en.\x02Tunnel\x02&Bearbeiten\x02Einen &leeren Tunnel hinzufügen…\x02Tunn" +
	"el hinzufügen\x02Markierte(n) Tunnel entfernen\x02Alle Tunnel in eine Zi" +
	"p-Datei exportieren\x02&Umschalten\x02Exportiere alle Tunnel in &Zip-Dat" +
	"ei\x02Ausgewählten Tunnel &bearbeiten…\x02Ausgewählte(n) Tunnel &löschen" +
	"\x02Ausgewählte Konfiguration konnte nicht importiert werden: %[1]v\x02K" +
	"onnte existierende Tunnel nicht auflisten: %[1]v\x02Es existiert bereits" +
	" ein Tunnel mit dem Namen „%[1]s“\x02Importieren der Konfiguration nicht" +
	" möglich: %[1]v\x02Tunnel importiert\x14\x01\x81\x01\x00\x02\x18\x02%[1]" +
	"d Tunnel importiert\x00\x18\x02%[1]d Tunnel importiert\x14\x02\x80\x01" +
	"\x02\x22\x02%[1]d von %[2]d Tunnel importiert\x00\x22\x02%[1]d von %[2]d" +
	" Tunnel importiert\x02Tunnel erstellen nicht möglich\x14\x01\x81\x01\x00" +
	"\x02\x16\x02%[1]d Tunnel löschen\x00\x16\x02%[1]d Tunnel löschen\x14\x01" +
	"\x81\x01\x00\x024\x02Möchten Sie diesen %[1]d Tunnel wirklich löschen?" +
	"\x003\x02Möchten Sie diese %[1]d Tunnel wirklich löschen?\x02Tunnel „%[1" +
	"]s“ löschen\x02Möchten Sie den Tunnel „%[1]s“ wirklich löschen?\x02%[1]s" +
	" Dieser Schritt kann nicht rückgängig gemacht werden.\x02Tunnel löschen " +
	"nicht möglich\x02Ein Tunnel konnte nicht gelöscht werden: %[1]s\x02Tunne" +
	"l konnten nicht gelöscht werden\x14\x01\x81\x01\x00\x02+\x02%[1]d Tunnel" +
	" konnte nicht entfernt werden.\x00-\x02%[1]d Tunnel konnten nicht gelösc" +
	"ht werden.\x02Konfigurationsdateien (*.zip, *.conf)|*.zip;*.conf|Alle Da" +
	"teien (*.*)|*.*\x02Importiere Tunnel aus Datei\x02Konfigurations-ZIP-Dat" +
	"eien (*.zip)|*.zip\x02Exportiere Tunnel in Zip-Datei\x02%[1]s (unsignier" +
	"t, keine Aktualisierungen)\x02Fehler beim Beenden von WireGuard\x02Der D" +
	"ienst konnte nicht gestoppt werden: %[1]v. Versuchen Sie WireGuard in de" +
	"r Dienstverwaltung zu beenden.\x02Eine Aktualisierung für WireGuard ist " +
	"verfügbar. Es ist höchst empfehlenswert diese sofort durchzuführen.\x02S" +
	"tatus: Auf Nutzer warten\x02Jetzt aktualisieren\x02Status: Auf Aktualisi" +
	"erungsdienst warten\x02Fehler: %[1]v. Bitte versuchen Sie es erneut.\x02" +
	"Status: Fertig!\x02http2: Framer %[1]p: Fehler beim dekodieren des gerad" +
	"e geschriebenen Frames\x02http2: Framer %[1]p: %[2]v geschrieben\x02http" +
	"2: Framer %[1]p: %[2]v gelesen\x02http2: hpack Feld %+[1]v dekodiert"

var enIndex = []uint32{ // 177 elements
	// Entry 0 - 1F
	0x00000000, 0x00000006, 0x00000039, 0x0000004f,
	0x00000064, 0x000000aa, 0x000000e9, 0x00000115,
	0x00000166, 0x000001c4, 0x00000200, 0x00000204,
	0x00000221, 0x00000241, 0x0000025f, 0x0000027f,
	0x000002a3, 0x000002c7, 0x000002d1, 0x000002da,
	0x000002e7, 0x000002f4, 0x00000301, 0x0000030e,
	0x0000031b, 0x0000032e, 0x0000034c, 0x00000367,
	0x0000037d, 0x000003a3, 0x000003af, 0x000003bc,
	// Entry 20 - 3F
	0x000003d9, 0x000003ec, 0x00000411, 0x00000445,
	0x00000459, 0x00000472, 0x0000048f, 0x000004b9,
	0x000004cf, 0x000004f3, 0x00000512, 0x00000537,
	0x00000548, 0x00000568, 0x00000587, 0x000005a9,
	0x000005c4, 0x000005e1, 0x000005e4, 0x000005e7,
	0x000005f7, 0x0000060c, 0x00000677, 0x0000067d,
	0x0000068a, 0x00000692, 0x0000069e, 0x000006a8,
	0x000006b4, 0x000006c1, 0x000006c6, 0x000006d1,
	// Entry 40 - 5F
	0x000006de, 0x000006ed, 0x000006fa, 0x00000704,
	0x0000071a, 0x0000072c, 0x00000736, 0x0000073e,
	0x00000759, 0x0000077a, 0x00000794, 0x000007b0,
	0x000007c1, 0x000007c6, 0x000007d8, 0x000007e4,
	0x000007eb, 0x000007f8, 0x00000802, 0x0000082a,
	0x00000948, 0x0000094e, 0x00000955, 0x00000965,
	0x00000972, 0x00000986, 0x000009aa, 0x000009ca,
	0x000009e0, 0x00000a19, 0x00000a3c, 0x00000a50,
	// Entry 60 - 7F
	0x00000a8f, 0x00000a96, 0x00000aa1, 0x00000aaa,
	0x00000ab7, 0x00000ac5, 0x00000ac9, 0x00000acf,
	0x00000adb, 0x00000aec, 0x00000af1, 0x00000afd,
	0x00000b2a, 0x00000b3d, 0x00000b51, 0x00000b5e,
	0x00000b92, 0x00000ba6, 0x00000bc0, 0x00000bf5,
	0x00000c0c, 0x00000c1c, 0x00000c2c, 0x00000c3f,
	0x00000c5e, 0x00000c64, 0x00000c7b, 0x00000c8c,
	0x00000c9a, 0x00000cab, 0x00000cbf, 0x00000ce4,
	// Entry 80 - 9F
	0x00000cfa, 0x00000d21, 0x00000d39, 0x00000d54,
	0x00000dac, 0x00000db4, 0x00000dba, 0x00000dcf,
	0x00000dda, 0x00000df4, 0x00000e0e, 0x00000e16,
	0x00000e34, 0x00000e4d, 0x00000e68, 0x00000e97,
	0x00000ec3, 0x00000efb, 0x00000f21, 0x00000f32,
	0x00000f68, 0x00000faf, 0x00000fc7, 0x00000ff9,
	0x0000106b, 0x00001085, 0x000010bf, 0x000010e2,
	0x000010fa, 0x00001123, 0x0000113c, 0x00001195,
	// Entry A0 - BF
	0x000011da, 0x000011f5, 0x0000121b, 0x00001231,
	0x00001254, 0x0000126c, 0x000012cb, 0x00001320,
	0x00001339, 0x00001344, 0x00001368, 0x00001388,
	0x0000139a, 0x000013d3, 0x000013f4, 0x00001414,
	0x00001436,
} // Size: 732 bytes

const enData string = "" + // Size: 5174 bytes
	"\x02Error\x02(no argument): elevate and install manager service\x02Usage" +
	": %[1]s [\x0a%[2]s]\x02Command Line Options\x02Unable to determine wheth" +
	"er the process is running under WOW64: %[1]v\x02You must use the 64-bit " +
	"version of WireGuard on this computer.\x02Unable to open current process" +
	" token: %[1]v\x02WireGuard may only be used by users who are a member of" +
	" the Builtin %[1]s group.\x02WireGuard is running, but the UI is only ac" +
	"cessible from desktops of the Builtin %[1]s group.\x02WireGuard system t" +
	"ray icon did not appear after 30 seconds.\x02Now\x02System clock wound b" +
	"ackward!\x14\x01\x81\x01\x00\x02\x0b\x02%[1]d year\x00\x0c\x02%[1]d year" +
	"s\x14\x01\x81\x01\x00\x02\x0a\x02%[1]d day\x00\x0b\x02%[1]d days\x14\x01" +
	"\x81\x01\x00\x02\x0b\x02%[1]d hour\x00\x0c\x02%[1]d hours\x14\x01\x81" +
	"\x01\x00\x02\x0d\x02%[1]d minute\x00\x0e\x02%[1]d minutes\x14\x01\x81" +
	"\x01\x00\x02\x0d\x02%[1]d second\x00\x0e\x02%[1]d seconds\x02%[1]s ago" +
	"\x02%[1]d\u00a0B\x02%.2[1]f\u00a0KiB\x02%.2[1]f\u00a0MiB\x02%.2[1]f" +
	"\u00a0GiB\x02%.2[1]f\u00a0TiB\x02%[1]s: %[2]q\x02Invalid IP address\x02I" +
	"nvalid network prefix length\x02Missing port from endpoint\x02Invalid en" +
	"dpoint host\x02Brackets must contain an IPv6 address\x02Invalid MTU\x02I" +
	"nvalid port\x02Invalid persistent keepalive\x02Invalid key: %[1]v\x02Key" +
	"s must decode to exactly 32 bytes\x02Number must be a number between 0 a" +
	"nd 2^64-1: %[1]v\x02Two commas in a row\x02Tunnel name is not valid\x02L" +
	"ine must occur in a section\x02Config key is missing an equals separator" +
	"\x02Key must have a value\x02Invalid key for [Interface] section\x02Inva" +
	"lid key for [Peer] section\x02An interface must have a private key\x02[n" +
	"one specified]\x02All peers must have public keys\x02Error in getting co" +
	"nfiguration\x02Invalid key for interface section\x02Protocol version mus" +
	"t be 1\x02Invalid key for peer section\x02, \x02, \x02About WireGuard" +
	"\x02WireGuard logo image\x02App version: %[1]s\x0aGo backend version: %[" +
	"2]s\x0aGo version: %[3]s\x0aOperating system: %[4]s\x0aArchitecture: %[5" +
	"]s\x02Close\x02♥ &Donate!\x02Status:\x02&Deactivate\x02&Activate\x02Publ" +
	"ic key:\x02Listen port:\x02MTU:\x02Addresses:\x02DNS servers:\x02Preshar" +
	"ed key:\x02Allowed IPs:\x02Endpoint:\x02Persistent keepalive:\x02Latest " +
	"handshake:\x02Transfer:\x02enabled\x02%[1]s received, %[2]s sent\x02Fail" +
	"ed to determine tunnel state\x02Failed to activate tunnel\x02Failed to d" +
	"eactivate tunnel\x02Interface: %[1]s\x02Peer\x02Create new tunnel\x02Edi" +
	"t tunnel\x02&Name:\x02&Public key:\x02(unknown)\x02&Block untunneled tra" +
	"ffic (kill-switch)\x02When a configuration has exactly one peer, and tha" +
	"t peer has an allowed IPs containing at least one of 0.0.0.0/0 or ::/0, " +
	"then the tunnel service engages a firewall ruleset to block all traffic " +
	"that is neither to nor from the tunnel interface, with special exception" +
	"s for DHCP and NDP.\x02&Save\x02Cancel\x02&Configuration:\x02Invalid nam" +
	"e\x02A name is required.\x02Tunnel name ‘%[1]s’ is invalid.\x02Unable to" +
	" list existing tunnels\x02Tunnel already exists\x02Another tunnel alread" +
	"y exists with the name ‘%[1]s’.\x02Unable to create new configuration" +
	"\x02Writing file failed\x02File ‘%[1]s’ already exists.\x0a\x0aDo you wa" +
	"nt to overwrite it?\x02Active\x02Activating\x02Inactive\x02Deactivating" +
	"\x02Unknown state\x02Log\x02&Copy\x02Select &all\x02&Save to file…\x02Ti" +
	"me\x02Log message\x02Text Files (*.txt)|*.txt|All Files (*.*)|*.*\x02Exp" +
	"ort log to file\x02&About WireGuard…\x02Tunnel Error\x02%[1]s\x0a\x0aPle" +
	"ase consult the log for more information.\x02%[1]s (out of date)\x02Wire" +
	"Guard Detection Error\x02Unable to wait for WireGuard window to appear: " +
	"%[1]v\x02WireGuard: Deactivated\x02Status: Unknown\x02Addresses: None" +
	"\x02&Manage tunnels…\x02&Import tunnel(s) from file…\x02E&xit\x02WireGua" +
	"rd Tunnel Error\x02WireGuard: %[1]s\x02Status: %[1]s\x02Addresses: %[1]s" +
	"\x02WireGuard Activated\x02The %[1]s tunnel has been activated.\x02WireG" +
	"uard Deactivated\x02The %[1]s tunnel has been deactivated.\x02An Update " +
	"is Available!\x02WireGuard Update Available\x02An update to WireGuard is" +
	" now available. You are advised to update as soon as possible.\x02Tunnel" +
	"s\x02&Edit\x02Add &empty tunnel…\x02Add Tunnel\x02Remove selected tunnel" +
	"(s)\x02Export all tunnels to zip\x02&Toggle\x02Export all tunnels to &zi" +
	"p…\x02Edit &selected tunnel…\x02&Remove selected tunnel(s)\x02Could not " +
	"import selected configuration: %[1]v\x02Could not enumerate existing tun" +
	"nels: %[1]v\x02Another tunnel already exists with the name ‘%[1]s’\x02Un" +
	"able to import configuration: %[1]v\x02Imported tunnels\x14\x01\x81\x01" +
	"\x00\x02\x16\x02Imported %[1]d tunnel\x00\x17\x02Imported %[1]d tunnels" +
	"\x14\x02\x80\x01\x02\x1f\x02Imported %[1]d of %[2]d tunnel\x00 \x02Impor" +
	"ted %[1]d of %[2]d tunnels\x02Unable to create tunnel\x14\x01\x81\x01" +
	"\x00\x02\x14\x02Delete %[1]d tunnel\x00\x15\x02Delete %[1]d tunnels\x14" +
	"\x01\x81\x01\x00\x024\x02Are you sure you would like to delete %[1]d tun" +
	"nel?\x005\x02Are you sure you would like to delete %[1]d tunnels?\x02Del" +
	"ete tunnel ‘%[1]s’\x02Are you sure you would like to delete tunnel ‘%[1]" +
	"s’?\x02%[1]s You cannot undo this action.\x02Unable to delete tunnel\x02" +
	"A tunnel was unable to be removed: %[1]s\x02Unable to delete tunnels\x14" +
	"\x01\x81\x01\x00\x02'\x02%[1]d tunnel was unable to be removed.\x00)\x02" +
	"%[1]d tunnels were unable to be removed.\x02Configuration Files (*.zip, " +
	"*.conf)|*.zip;*.conf|All Files (*.*)|*.*\x02Import tunnel(s) from file" +
	"\x02Configuration ZIP Files (*.zip)|*.zip\x02Export tunnels to zip\x02%[" +
	"1]s (unsigned build, no updates)\x02Error Exiting WireGuard\x02Unable to" +
	" exit service due to: %[1]v. You may want to stop WireGuard from the ser" +
	"vice manager.\x02An update to WireGuard is available. It is highly advis" +
	"able to update without delay.\x02Status: Waiting for user\x02Update Now" +
	"\x02Status: Waiting for updater service\x02Error: %[1]v. Please try agai" +
	"n.\x02Status: Complete!\x02http2: Framer %[1]p: failed to decode just-wr" +
	"itten frame\x02http2: Framer %[1]p: wrote %[2]v\x02http2: Framer %[1]p: " +
	"read %[2]v\x02http2: decoded hpack field %+[1]v"

var faIndex = []uint32{ // 177 elements
	// Entry 0 - 1F
	0x00000000, 0x00000007, 0x00000007, 0x00000007,
	0x0000002b, 0x0000002b, 0x00000093, 0x00000093,
	0x00000093, 0x00000093, 0x00000093, 0x000000a3,
	0x000000a3, 0x000000c6, 0x000000e9, 0x00000110,
	0x0000013b, 0x00000166, 0x00000173, 0x00000183,
	0x00000183, 0x00000183, 0x00000183, 0x00000183,
	0x00000183, 0x000001b0, 0x000001b0, 0x000001b0,
	0x000001b0, 0x000001b0, 0x000001ca, 0x000001e2,
	// Entry 20 - 3F
	0x000001e2, 0x000001e2, 0x000001e2, 0x000001e2,
	0x000001e2, 0x000001e2, 0x000001e2, 0x000001e2,
	0x00000218, 0x00000218, 0x00000218, 0x00000218,
	0x0000022c, 0x0000027c, 0x000002a6, 0x000002a6,
	0x000002a6, 0x000002a6, 0x000002aa, 0x000002ae,
	0x000002c5, 0x000002c5, 0x000002c5, 0x000002ce,
	0x000002e5, 0x000002f1, 0x0000030c, 0x00000321,
	0x00000336, 0x00000349, 0x0000034e, 0x00000361,
	// Entry 40 - 5F
	0x00000375, 0x0000039d, 0x000003b0, 0x000003c5,
	0x000003f0, 0x000003f0, 0x000003fe, 0x0000040e,
	0x0000040e, 0x0000040e, 0x0000040e, 0x0000040e,
	0x0000041e, 0x00000427, 0x00000444, 0x0000045a,
	0x00000463, 0x00000479, 0x0000048c, 0x0000048c,
	0x0000048c, 0x00000498, 0x0000049f, 0x000004b2,
	0x000004c8, 0x000004e9, 0x000004e9, 0x0000052f,
	0x0000055c, 0x0000055c, 0x0000055c, 0x0000055c,
	// Entry 60 - 7F
	0x0000055c, 0x00000565, 0x00000585, 0x00000594,
	0x000005ba, 0x000005d6, 0x000005ec, 0x000005fa,
	0x000005fa, 0x0000061b, 0x00000624, 0x00000645,
	0x00000645, 0x00000681, 0x0000069c, 0x000006b0,
	0x000006b0, 0x000006b0, 0x000006b0, 0x000006b0,
	0x000006b0, 0x000006cd, 0x000006e7, 0x00000708,
	0x00000708, 0x00000708, 0x00000724, 0x00000724,
	0x00000736, 0x0000074f, 0x00000769, 0x0000078b,
	// Entry 80 - 9F
	0x000007a9, 0x000007a9, 0x000007de, 0x00000817,
	0x00000817, 0x00000827, 0x00000835, 0x00000863,
	0x00000879, 0x0000089e, 0x000008d3, 0x000008d3,
	0x0000090c, 0x0000090c, 0x0000090c, 0x0000090c,
	0x0000090c, 0x0000090c, 0x0000090c, 0x0000092e,
	0x00000971, 0x000009c9, 0x000009f6, 0x00000a2b,
	0x00000a2b, 0x00000a47, 0x00000a47, 0x00000a47,
	0x00000a79, 0x00000a79, 0x00000aae, 0x00000aae,
	// Entry A0 - BF
	0x00000aae, 0x00000ae1, 0x00000b1d, 0x00000b4b,
	0x00000b4b, 0x00000b81, 0x00000b81, 0x00000b81,
	0x00000bb2, 0x00000bdb, 0x00000c24, 0x00000c5c,
	0x00000c77, 0x00000c77, 0x00000c77, 0x00000c77,
	0x00000c77,
} // Size: 732 bytes

const faData string = "" + // Size: 3191 bytes
	"\x02خطا\x02گزینه\u200cهای خط فرمان\x02شما باید نگارش ۶۴-بیت WireGuard را" +
	" در این رایانه استفاده کنید.\x02هم اکنون\x14\x01\x81\x01\x00\x02\x0d\x02" +
	"%[1]d سال\x00\x0d\x02%[1]d سال\x14\x01\x81\x01\x00\x02\x0d\x02%[1]d روز" +
	"\x00\x0d\x02%[1]d روز\x14\x01\x81\x01\x00\x02\x0f\x02%[1]d ساعت\x00\x0f" +
	"\x02%[1]d ساعت\x14\x01\x81\x01\x00\x02\x11\x02%[1]d دقیقه\x00\x11\x02%[1" +
	"]d دقیقه\x14\x01\x81\x01\x00\x02\x11\x02%[1]d ثانیه\x00\x11\x02%[1]d ثان" +
	"یه\x02%[1]s پیش\x02%[1]d\u00a0بایت\x02نشانی آی\u200cپی نامعتبر است\x02M" +
	"TU نامعتبر است\x02پورت نامعتبر\x02کلید باید یک مقدار داشته باشد\x02[مشخص" +
	" نشده]\x02همه همتاها باید کلید\u200cهای عمومی داشته باشند\x02خطا در دریا" +
	"فت پیکربندی\x02، \x02، \x02درباره WireGuard\x02بستن\x02♥&کمک\u200cمالی!" +
	"\x02وضعیت:\x02&غیرفعال\u200cسازی\x02&فعال\u200cسازی\x02کلید عمومی:\x02پو" +
	"رت شنود:\x02MTU:\x02نشانی\u200cها:\x02سرورهای DNS:\x02کلید از پیش تقسیم" +
	" شده:\x02IPهای مجاز:\x02نقطه پایان:\x02زنده نگه\u200cداشتن پیوسته:\x02ان" +
	"تقال:\x02فعال شده\x02رابط: %[1]s\x02همتا\x02ایجاد تونل جدید\x02ویرایش ت" +
	"ونل\x02&نام:\x02&کلید عمومی:\x02(ناشناخته)\x02&ذخیره\x02لغو\x02&پیکربند" +
	"ی:\x02نام نامعتبر\x02یک نام الزامی است.\x02نمی\u200cتوان تونل\u200cهای " +
	"موجود را فهرست کرد\x02تونل هم\u200cاکنون موجود است\x02فعال\x02در حال فع" +
	"ال\u200cسازی\x02غیرفعال\x02در حال غیرفعال\u200cسازی\x02وضعیت ناشناخته" +
	"\x02گزارش وقایع\x02&روگرفت\x02&ذخیره در پرونده…\x02زمان\x02پیام گزارش رو" +
	"یداد\x02برون\u200cبرد گزارش رویداد به پرونده\x02&درباره WireGuard…\x02خ" +
	"طالی تونل\x02وضعیت: ناشناخته\x02نشانی\u200cها: هیچ\x02&مدیریت تونل" +
	"\u200cها…\x02خطای تونل WireGuard\x02وضعیت: %[1]s\x02نشانی\u200cها: %[1]s" +
	"\x02WireGuard فعال\u200cشد\x02تونل %[1]s فعال\u200cشده.\x02WireGuard غیر" +
	"فعال شد\x02یک به\u200cروزرسانی در دسترس است!\x02به\u200cروزرسانی WireGu" +
	"ard در دسترس است\x02تونل\u200cها\x02&ویرایش\x02افزودن &خالی\u200cکردن تو" +
	"نل…\x02افزودن تونل\x02حذف تونل(ها) انتخابی\x02برون\u200cبری همه تونل" +
	"\u200cها به زیپ\x02برون\u200cبری همه تونل\u200cها به &زیپ…\x02تونل\u200c" +
	"های وارد شده\x14\x01\x81\x01\x00\x02\x1d\x02%[1]d تونل وارد شد\x00\x1d" +
	"\x02%[1]d تونل وارد شد\x14\x02\x80\x01\x02(\x02%[1]d از %[2]d تونل وارد " +
	"شد\x00(\x02%[1]d از %[2]d تونل وارد شد\x02نمی\u200cتوان تونل ایجاد کرد" +
	"\x14\x01\x81\x01\x00\x02\x16\x02حذف %[1]d تونل\x00\x16\x02حذف %[1]d تونل" +
	"\x02حذف تونل ‘%[1]s’\x02حذف تونل\u200c امکان\u200cپذیر نیست\x02نمی\u200c" +
	"توان تونل\u200cها را حذف کرد\x02وارد کردن تونل(ها) از پرونده\x02پرونده" +
	"\u200cهای پیکربندی زیپ (*.zip)|*.zip\x02برون\u200cبری تونل\u200cها به زی" +
	"پ\x02خطا در هنگام خارج شدن از WireGuard\x02وضعیت: درانتظار برای کاربر" +
	"\x02اکنون به\u200cروز رسانی کن\x02وضعیت: درانتظار برای سرویس به\u200cروز" +
	"رسانی\x02خطا: %[1]v. لطفا دوباره تلاش کنید.\x02وضعیت: کامل شد!"

var frIndex = []uint32{ // 177 elements
	// Entry 0 - 1F
	0x00000000, 0x00000007, 0x00000046, 0x00000063,
	0x00000083, 0x000000cb, 0x00000108, 0x00000141,
	0x000001a3, 0x0000021b, 0x00000278, 0x00000283,
	0x000002a6, 0x000002c2, 0x000002e2, 0x00000304,
	0x00000328, 0x0000034e, 0x0000035b, 0x00000364,
	0x00000371, 0x0000037e, 0x0000038b, 0x00000398,
	0x000003a6, 0x000003bc, 0x000003e4, 0x0000040a,
	0x00000433, 0x00000465, 0x00000474, 0x00000484,
	// Entry 20 - 3F
	0x000004bb, 0x000004d3, 0x00000500, 0x0000053b,
	0x00000557, 0x00000570, 0x0000059c, 0x000005d7,
	0x000005f2, 0x0000061e, 0x00000645, 0x0000066d,
	0x00000685, 0x000006bd, 0x000006e4, 0x00000710,
	0x00000732, 0x0000075e, 0x00000761, 0x00000763,
	0x0000077a, 0x00000795, 0x0000081b, 0x00000822,
	0x00000836, 0x0000083e, 0x0000084b, 0x00000854,
	0x00000864, 0x00000875, 0x0000087b, 0x00000886,
	// Entry 40 - 5F
	0x00000895, 0x000008ab, 0x000008c5, 0x000008dc,
	0x0000090a, 0x00000931, 0x0000093d, 0x00000948,
	0x00000969, 0x00000995, 0x000009b4, 0x000009d8,
	0x000009ea, 0x000009f4, 0x00000a0d, 0x00000a20,
	0x00000a27, 0x00000a38, 0x00000a45, 0x00000a78,
	0x00000bd3, 0x00000be0, 0x00000be8, 0x00000bf9,
	0x00000c08, 0x00000c20, 0x00000c4a, 0x00000c7f,
	0x00000c95, 0x00000cc9, 0x00000cf9, 0x00000d17,
	// Entry 60 - 7F
	0x00000d56, 0x00000d61, 0x00000d75, 0x00000d82,
	0x00000d9a, 0x00000da8, 0x00000db0, 0x00000db8,
	0x00000dcc, 0x00000dec, 0x00000df2, 0x00000e05,
	0x00000e3e, 0x00000e62, 0x00000e7a, 0x00000e8b,
	0x00000ed5, 0x00000ee7, 0x00000f09, 0x00000f4b,
	0x00000f62, 0x00000f72, 0x00000f84, 0x00000f9c,
	0x00000fce, 0x00000fd7, 0x00000ff2, 0x00001004,
	0x00001012, 0x00001023, 0x00001035, 0x00001053,
	// Entry 80 - 9F
	0x00001069, 0x0000108b, 0x000010a4, 0x000010ca,
	0x0000113f, 0x00001147, 0x00001151, 0x0000116c,
	0x0000117e, 0x000011a9, 0x000011cc, 0x000011d6,
	0x000011fd, 0x00001222, 0x0000124e, 0x0000128c,
	0x000012c3, 0x000012ef, 0x0000131e, 0x00001330,
	0x00001367, 0x000013b0, 0x000013cf, 0x00001407,
	0x0000146b, 0x0000148b, 0x000014c1, 0x000014f0,
	0x00001512, 0x00001547, 0x0000156b, 0x000015d7,
	// Entry A0 - BF
	0x0000162a, 0x00001658, 0x00001684, 0x000016a2,
	0x000016d3, 0x000016f1, 0x0000176c, 0x000017e5,
	0x0000180a, 0x00001824, 0x00001853, 0x00001878,
	0x00001889, 0x000018ce, 0x000018f3, 0x00001915,
	0x00001939,
} // Size: 732 bytes

const frData string = "" + // Size: 6457 bytes
	"\x02Erreur\x02(sans argument) : élever et installer service du gestionna" +
	"ire\x02Utilisation : %[1]s [\x0a%[2]s]\x02Options de la ligne de command" +
	"e\x02Impossible de détecter si le processus s’exécute sous WOW64 : %[1]v" +
	"\x02Utilisez la version 64 bits du WireGuard sur cet ordinateur.\x02Impo" +
	"ssible d'ouvrir le jeton de processus actuel : %[1]v\x02Seulement les ut" +
	"ilisateurs qui sont membres du groupe intégré %[1]s peuvent utiliser Wir" +
	"eGuard.\x02WireGuard est en cours d'exécution, mais l'IU est accessible " +
	"seulement à partir des bureaux du group intégré %[1]s.\x02L’icône de la " +
	"barre d’état système du WireGuard n'est pas apparue après 30 secondes." +
	"\x02Maintenant\x02L’horloge système est inversé!\x14\x01\x81\x01\x00\x02" +
	"\x09\x02%[1]d an\x00\x0a\x02%[1]d ans\x14\x01\x81\x01\x00\x02\x0b\x02%[1" +
	"]d jour\x00\x0c\x02%[1]d jours\x14\x01\x81\x01\x00\x02\x0c\x02%[1]d heur" +
	"e\x00\x0d\x02%[1]d heures\x14\x01\x81\x01\x00\x02\x0d\x02%[1]d minute" +
	"\x00\x0e\x02%[1]d minutes\x14\x01\x81\x01\x00\x02\x0e\x02%[1]d seconde" +
	"\x00\x0f\x02%[1]d secondes\x02Il y a %[1]s\x02%[1]d\u00a0o\x02%.2[1]f" +
	"\u00a0Kio\x02%.2[1]f\u00a0Mio\x02%.2[1]f\u00a0Gio\x02%.2[1]f\u00a0Tio" +
	"\x02%[1]s : %[2]q\x02Adresse IP non valide\x02Longueur du préfixe réseau" +
	" non valide\x02Port manquant au point de terminaison\x02Hôte du point de" +
	" terminaison non valide\x02Il faut mettre un adresse IPv6 entre les croc" +
	"hets\x02MTU non valide\x02Port non valide\x02Conservation de connexion a" +
	"ctive permanente non valide\x02Clé non valide : %[1]v\x02Clés doivent êt" +
	"re décodées sur 32 octets\x02Le numéro doit être un numéro entre 0 et 2^" +
	"64-1 : %[1]v\x02Deux virgules consécutives\x02Nom du tunnel non valide" +
	"\x02Une ligne doit apparaître dans une section\x02Il manque le séparateu" +
	"r égal à la clé de configuration\x02Clé doit avoir une valeur\x02Clé non" +
	" valide pour la section [Interface]\x02Clé non valide pour la section [P" +
	"eer]\x02L'interface doit avoir une clé privée\x02[aucune spécification]" +
	"\x02Tous les homologues doivent avoirs les clés publiques.\x02Erreur d'o" +
	"btention de la configuration\x02Clé non valide pour la section d'interfa" +
	"ce\x02Version du protocole doit être 1\x02Clé non valide pour la section" +
	" d'homologue\x02, \x02 \x02À propos du WireGuard\x02Image du logo du Wir" +
	"eGuard\x02Version de l'application : %[1]s\x0aVersion wireguard-go : %[2" +
	"]s\x0aVersion Go : %[3]s\x0aSystème d'exploitation : %[4]s\x0aArchitectu" +
	"re : %[5]s\x02Fermer\x02♥ &Faites un don!\x02État :\x02&Désactiver\x02&A" +
	"ctiver\x02Clé publique :\x02Port d'écoute :\x02MTU :\x02Adresses :\x02Se" +
	"rveurs DNS :\x02Clé pré-partagée :\x02Adresses IP autorisées :\x02Point " +
	"de terminaison :\x02Conservation de connexion active permanente :\x02Der" +
	"nier établissement d'une liaison :\x02Transfert :\x02activé(e)\x02%[1]s " +
	"reçu(e), %[2]s envoyé(e)\x02Impossible de déterminer l'état du tunnel" +
	"\x02Impossible d'activer le tunnel\x02Impossible de désactiver le tunnel" +
	"\x02Interface : %[1]s\x02Homologue\x02Créer un nouveau tunnel\x02Modifie" +
	"r le tunnel\x02&Nom :\x02&Clé publique :\x02(inconnu(e))\x02&Bloquer tou" +
	"s le trafic hors tunnel (interrupteur)\x02Si la configuration a exacteme" +
	"nt un homologue et si cet homologue a une addresse IP approvée contenant" +
	" au moins un de 0.0.0.0/0\u00a0ou\u00a0::/0, le service de tunnelisation" +
	" utilise l'ensemble de règles du pare-feu afin de blocquer tout le traff" +
	"ic, sauf le traffic vers ou dépuis l'interface de tunnel et l'exceptions" +
	" speciales liées à DHCP et NDP.\x02&Enregistrer\x02Annuler\x02&Configura" +
	"tion :\x02Nom non valide\x02Le nom est obligatoire.\x02Nom de tunnel « %" +
	"[1]s » est non valide.\x02Impossible de créer une liste des tunnels exis" +
	"tants\x02Tunnel existe déjà.\x02Nom « %[1]s » est déjà utilisé pour un t" +
	"unnel.\x02Impossible de créer une configuration nouvelle\x02Échec d'écri" +
	"ture du fichier\x02Fichier « %[1]s » existe déjà.\x0a\x0aVoulez-vous le " +
	"remplacer ?\x02Activé(e)\x02Activation en cours\x02Inactivé(e)\x02Désact" +
	"ivation en cours\x02État inconnu\x02Journal\x02&Copier\x02Sélectionner &" +
	"tout\x02&Enregistrer dans le fichier…\x02Temps\x02Message du journal\x02" +
	"Fichiers texte (*.txt)|*.txt|Tous les fichiers (*.*)|*.*\x02Exporter le " +
	"journal vers le fichier\x02&À propos WireGuard…\x02Erreur du tunnel\x02%" +
	"[1]s\x0a\x0aConsultez le journal pour plus d’informations, s'il vous pla" +
	"ît.\x02%[1]s (obsolète)\x02Erreur de détection du WireGuard\x02Impossib" +
	"le d’attendre l'affichage du fenêtre WireGuard : %[1]v\x02WireGuard: Dés" +
	"activé\x02État : Inconnu\x02Adresses : Aucune\x02&Gestion des tunnels…" +
	"\x02&Importer le(s) tunnel(s) à partir du fichier…\x02Q&uitter\x02Erreur" +
	" du tunnel WireGuard\x02WireGuard : %[1]s\x02État : %[1]s\x02Adresses : " +
	"%[1]s\x02WireGuard activé\x02Tunnel %[1]s a été activé.\x02WireGuard dés" +
	"activé\x02Tunnel %[1]s a été désactivé.\x02Mise à jour disponible!\x02Wi" +
	"reGuard mise à jour est disponible\x02Une mise à jour du WireGuard est d" +
	"isponible. Il est conseillé de mettre votre WireGuard à jour dès que pos" +
	"sible.\x02Tunnels\x02&Modifier\x02Ajouter un &tunnel vide…\x02Ajouter le" +
	" tunnel\x02Supprimer le(s) tunnel(s) sélectionné(s)\x02Exporter tous les" +
	" tunnels vers zip\x02&Basculer\x02Exporter tous les tunnels vers &zip…" +
	"\x02Modifier &le tunnel sélectionné…\x02&Supprimer le(s) tunnel(s) sélec" +
	"tionné(s)\x02Impossible d'importer la configuration sélectionnée : %[1]v" +
	"\x02Impossible d'énumérer les tunnels existantes : %[1]v\x02Un tunnel no" +
	"mmé « %[1]s » existe déjà.\x02Impossible d'importer la configuration : %" +
	"[1]v\x02Tunnels importés\x14\x01\x81\x01\x00\x02\x16\x02%[1]d tunnel imp" +
	"orté\x00\x18\x02%[1]d tunnels importés\x14\x02\x80\x01\x02 \x02%[1]d de " +
	"%[2]d tunnels importé\x00!\x02%[1]d de %[2]d tunnels importés\x02Impossi" +
	"ble de créer le tunnel\x14\x01\x81\x01\x00\x02\x17\x02Supprimer %[1]d tu" +
	"nnel\x00\x18\x02Supprimer %[1]d tunnels\x14\x01\x81\x01\x00\x02-\x02Voul" +
	"ez-vous vraiment supprimer %[1]d tunnel?\x00.\x02Voulez-vous vraiment su" +
	"pprimer %[1]d tunnels?\x02Supprimer le tunnel ‘%[1]s’\x02Voulez-vous vra" +
	"iment supprimer le tunnel « %[1]s »?\x02%[1]s Vous ne pouvez pas annuler" +
	" cette action.\x02Impossible de supprimer le tunnel\x02Il a été impossib" +
	"le de supprimer un tunnel : %[1]s\x02Impossible de supprimer les tunnels" +
	"\x14\x01\x81\x01\x00\x021\x02Il a été impossible de supprimer %[1]d tunn" +
	"el.\x002\x02Il a été impossible de supprimer %[1]d tunnels.\x02Fichiers " +
	"de configuration (*.zip, *.conf)|*.zip;*.conf|Tous les fichiers (*.*)|*." +
	"*\x02Importer le(s) tunnel(s) à partir du fichier\x02Fichiers de configu" +
	"ration ZIP (*.zip)|*.zip\x02Exporter les tunnels vers zip\x02%[1]s (vers" +
	"ion non signée, aucune mise à jour)\x02Erreur de sortie du WireGuard\x02" +
	"Impossible de quitter le service en raison de : %[1]v. Essayez d'arrêter" +
	" WireGuard à partir du gestionnair des services.\x02Une mise à jour du W" +
	"ireGuard est disponible. Il est fortement conseillé de metter votre Wire" +
	"Guard à jour sans délai.\x02État: En attente de l’utilisateur\x02Mettre " +
	"à jour maintenant\x02État: En attente du programme de mise à jour\x02Er" +
	"reur : %[1]v. Veuillez réessayer.\x02État: Terminé!\x02http2: Trameur %[" +
	"1]p : impossible de décoder la trame just écrite.\x02http2: Trameur %[1]" +
	"p: a écrit %[2]v\x02http2: Trameur %[1]p : a lu %[2]v\x02http2 : champ h" +
	"pack %+[1]v décodé"

var idIndex = []uint32{ // 177 elements
	// Entry 0 - 1F
	0x00000000, 0x0000000a, 0x00000047, 0x00000062,
	0x00000074, 0x000000bf, 0x000000fe, 0x0000012f,
	0x00000187, 0x000001e0, 0x00000215, 0x0000021e,
	0x00000231, 0x00000250, 0x00000262, 0x00000273,
	0x00000286, 0x00000299, 0x000002a9, 0x000002b1,
	0x000002bd, 0x000002c9, 0x000002d5, 0x000002e1,
	0x000002ee, 0x00000304, 0x0000031f, 0x0000033f,
	0x00000359, 0x0000037f, 0x0000038f, 0x000003a0,
	// Entry 20 - 3F
	0x000003c1, 0x000003d7, 0x000003ff, 0x00000431,
	0x0000044b, 0x00000463, 0x00000480, 0x00000480,
	0x0000049b, 0x000004c5, 0x000004ea, 0x0000050f,
	0x00000520, 0x00000548, 0x0000056c, 0x00000596,
	0x000005ad, 0x000005d2, 0x000005d5, 0x000005d5,
	0x000005e7, 0x000005e7, 0x0000064e, 0x00000654,
	0x00000661, 0x00000669, 0x00000669, 0x00000669,
	0x00000669, 0x00000669, 0x00000669, 0x00000669,
	// Entry 40 - 5F
	0x00000669, 0x00000669, 0x00000669, 0x00000669,
	0x00000669, 0x00000669, 0x00000669, 0x00000669,
	0x00000669, 0x00000669, 0x00000669, 0x00000669,
	0x00000669, 0x00000669, 0x00000669, 0x00000669,
	0x00000669, 0x00000669, 0x00000669, 0x00000669,
	0x00000669, 0x00000669, 0x00000669, 0x00000669,
	0x00000669, 0x00000669, 0x00000669, 0x00000669,
	0x00000669, 0x00000669, 0x00000669, 0x00000669,
	// Entry 60 - 7F
	0x00000669, 0x0000066f, 0x0000067c, 0x00000685,
	0x00000693, 0x000006aa, 0x000006b2, 0x000006b8,
	0x000006c4, 0x000006e1, 0x000006e7, 0x000006f1,
	0x00000721, 0x00000739, 0x0000074f, 0x0000075b,
	0x00000791, 0x000007a4, 0x000007bb, 0x000007f0,
	0x00000809, 0x00000821, 0x00000830, 0x00000843,
	0x0000085e, 0x00000866, 0x0000087c, 0x0000088d,
	0x0000089b, 0x0000089b, 0x0000089b, 0x0000089b,
	// Entry 80 - 9F
	0x0000089b, 0x0000089b, 0x0000089b, 0x0000089b,
	0x0000089b, 0x0000089b, 0x0000089b, 0x0000089b,
	0x0000089b, 0x0000089b, 0x0000089b, 0x0000089b,
	0x000008ba, 0x000008d3, 0x000008ea, 0x00000920,
	0x00000920, 0x00000920, 0x00000920, 0x00000920,
	0x00000920, 0x00000920, 0x00000920, 0x00000920,
	0x00000920, 0x00000920, 0x00000920, 0x00000920,
	0x00000920, 0x00000920, 0x00000920, 0x00000920,
	// Entry A0 - BF
	0x00000920, 0x00000920, 0x00000920, 0x00000920,
	0x00000920, 0x00000920, 0x00000920, 0x00000920,
	0x00000920, 0x00000920, 0x00000920, 0x00000920,
	0x00000920, 0x00000920, 0x00000920, 0x00000920,
	0x00000920,
} // Size: 732 bytes

const idData string = "" + // Size: 2336 bytes
	"\x02Kesalahan\x02(tidak ada argumen): naikkan akses dan instal servis ma" +
	"najer\x02Penggunaan: %[1]s [\x0a%[2]s]\x02Opsi Command Line\x02Tidak dap" +
	"at menentukan apakah proses sedang berjalan di bawah WOW64: %[1]v\x02And" +
	"a harus menggunakan WireGuard versi 64-bit di komputer ini.\x02Tidak dap" +
	"at membuka token proses saat ini: %[1]v\x02WireGuard hanya dapat digunak" +
	"an oleh pengguna yang merupakan anggota grup Bawaan %[1]s.\x02WireGuard " +
	"sedang berjalan, tetapi UI hanya dapat diakses dari desktop grup Bawaan " +
	"%[1]s.\x02Ikon sistem WireGuard tidak muncul setelah 30 detik.\x02Sekara" +
	"ng\x02Jam sistem mundur!\x14\x01\x81\x01\x00\x00\x18\x02%[1]d tahun\x0a%" +
	"[1]d tahun\x14\x01\x81\x01\x00\x00\x0b\x02%[1]d Hari\x14\x01\x81\x01\x00" +
	"\x00\x0a\x02%[1]d jam\x14\x01\x81\x01\x00\x00\x0c\x02%[1]d menit\x14\x01" +
	"\x81\x01\x00\x00\x0c\x02%[1]d detik\x02%[1]s yang lalu\x02%[1]d B\x02%.2" +
	"[1]f KiB\x02%.2[1]f MiB\x02%.2[1]f GiB\x02%.2[1]f TiB\x02%[1]s: %[2]q" +
	"\x02Alamat IP tidak valid\x02Network prefix tidak valid\x02Port belum te" +
	"risi dari endpoint\x02Host endpoint tidak valid\x02Dalam Kurung harus be" +
	"risi alamat IPv6\x02MTU tidak valid\x02Port tidak valid\x02Persistent ke" +
	"epalive tidak valid\x02Kunci tidak sah:%[1]v\x02Kunci harus diterjemahka" +
	"n tepat 32 byte\x02Nomor harus diantara 0 sampai dengan 2^64-1:%[1]v\x02" +
	"Dua koma dalam satu baris\x02Nama Tunnel tidak valid\x02Garis harus munc" +
	"ul perbagian\x02Kunci harus memiliki value\x02Kunci tidak valid pada bag" +
	"ian [Interface]\x02Kunci tidak valid pada bagian [Peer]\x02Interface har" +
	"us memiliki Private Key\x02Tidak Ditetapkan\x02Semua peers harus memilik" +
	"i kunci publik\x02Eror ketika mendapatkan konfigurasi\x02Kunci tidak val" +
	"id pada bagian [Interface]\x02Versi protokol harus 1\x02Kunci tidak vali" +
	"d pada bagian [Peer]\x02, \x02Tentang WireGuard\x02Versi Aplikasi: %[1]s" +
	"\x0aVersi back-end Go: %[2]s\x0aVersi Go: %[3]s\x0aSistem Operasi: %[4]s" +
	"\x0aArsitektur: %[5]s\x02Tutup\x02♥ &Donasi!\x02Status:\x02Aktif\x02Meng" +
	"aktifkan\x02Nonaktif\x02Menonaktifkan\x02Status tidak diketahui\x02Catat" +
	"an\x02Salin\x02Pilih semua\x02Menyimpan ke dalam berkas…\x02Waktu\x02Pes" +
	"an log\x02Berkas Txt (*.Txt)|*.Txt|Semua berkas (*.*)|*.*\x02Ekspor log " +
	"kedalam file\x02&Tentang WireGuard…\x02Tunnel eror\x02%[1]s\x0a\x0aSilak" +
	"an baca log untuk informasi lebih lanjut.\x02%[1]s (kadaluarsa)\x02Detek" +
	"si eror WireGuard\x02Tidak dapat menunggu jendela WireGuard muncul: %[1]" +
	"v\x02WireGuard: Dinonaktifkan\x02Status: Tidak diketahui\x02Alamat: Koso" +
	"ng\x02&Manajer Tunnel…\x02&Impor tunnel dari file…\x02&Keluar\x02Wiregua" +
	"rd Tunnel Eror\x02WireGuard: %[1]s\x02Status: %[1]s\x02Ekspor semua tunn" +
	"el ke &zip…\x02Ubah tunnel &terpilih…\x02&Hapus tunnel terpilih\x02Tidak" +
	" dapat mengimpor konfigurasi yang dipilih: %[1]v"

var itIndex = []uint32{ // 177 elements
	// Entry 0 - 1F
	0x00000000, 0x00000007, 0x00000044, 0x0000005d,
	0x00000075, 0x000000bd, 0x00000103, 0x0000013c,
	0x00000193, 0x00000204, 0x00000258, 0x0000025c,
	0x00000283, 0x000002a2, 0x000002c5, 0x000002e2,
	0x00000305, 0x0000032a, 0x00000333, 0x0000033c,
	0x00000349, 0x00000356, 0x00000363, 0x00000370,
	0x0000037d, 0x00000395, 0x000003bf, 0x000003dc,
	0x000003fa, 0x0000042a, 0x00000439, 0x0000044a,
	// Entry 20 - 3F
	0x0000046a, 0x00000483, 0x000004b5, 0x000004f4,
	0x0000050c, 0x0000052d, 0x0000055a, 0x0000055a,
	0x00000579, 0x000005a6, 0x000005ce, 0x000005fb,
	0x0000060d, 0x0000063b, 0x0000066b, 0x0000069d,
	0x000006c6, 0x000006ec, 0x000006ef, 0x000006f1,
	0x0000070b, 0x0000072a, 0x000007a2, 0x000007a9,
	0x000007c1, 0x000007c8, 0x000007d3, 0x000007db,
	0x000007ec, 0x000007fe, 0x00000803, 0x0000080e,
	// Entry 40 - 5F
	0x0000081a, 0x00000830, 0x0000083f, 0x00000849,
	0x0000085f, 0x00000874, 0x00000883, 0x0000088d,
	0x000008ab, 0x000008de, 0x00000902, 0x00000929,
	0x0000093c, 0x00000941, 0x0000094d, 0x0000095d,
	0x00000964, 0x00000976, 0x00000984, 0x000009b4,
	0x00000add, 0x00000ae4, 0x00000aec, 0x00000afd,
	0x00000b0d, 0x00000b23, 0x00000b51, 0x00000b79,
	0x00000b8f, 0x00000bc4, 0x00000bef, 0x00000c0f,
	// Entry 60 - 7F
	0x00000c46, 0x00000c4d, 0x00000c59, 0x00000c62,
	0x00000c71, 0x00000c83, 0x00000c87, 0x00000c8e,
	0x00000c9f, 0x00000cb1, 0x00000cb7, 0x00000cc8,
	0x00000cfb, 0x00000d0f, 0x00000d2d, 0x00000d3f,
	0x00000d72, 0x00000d83, 0x00000da6, 0x00000deb,
	0x00000e02, 0x00000e15, 0x00000e28, 0x00000e3e,
	0x00000e59, 0x00000e5f, 0x00000e7a, 0x00000e8b,
	0x00000e98, 0x00000ea9, 0x00000ebc, 0x00000edf,
	// Entry 80 - 9F
	0x00000ef5, 0x00000f1b, 0x00000f3c, 0x00000f63,
	0x00000fc2, 0x00000fc9, 0x00000fd3, 0x00000fea,
	0x00000ffa, 0x00001015, 0x00001033, 0x0000103c,
	0x0000105b, 0x0000107e, 0x0000109c, 0x000010d7,
	0x00001107, 0x0000113b, 0x0000116a, 0x0000117b,
	0x000011b2, 0x000011fa, 0x00001217, 0x0000124a,
	0x000012ab, 0x000012c6, 0x000012fb, 0x0000132b,
	0x0000134b, 0x0000137d, 0x0000139c, 0x00001403,
	// Entry A0 - BF
	0x0000144e, 0x00001465, 0x0000148e, 0x000014a4,
	0x000014d7, 0x000014ff, 0x00001571, 0x000015d6,
	0x000015f3, 0x00001600, 0x0000162f, 0x0000164c,
	0x0000165d, 0x000016a3, 0x000016c9, 0x000016ed,
	0x00001714,
} // Size: 732 bytes

const itData string = "" + // Size: 5908 bytes
	"\x02Errore\x02(nessun argomento): eleva e installa il servizio di gestio" +
	"ne\x02Utilizzo: %[1]s [\x0a%[2]s]\x02Opzioni riga di comando\x02Impossib" +
	"ile determinare se il processo è in esecuzione in WOW64: %[1]v\x02Devi u" +
	"tilizzare la versione a 64 bit di WireGuard su questo computer.\x02Impos" +
	"sibile aprire il token del processo corrente: %[1]v\x02WireGuard può ess" +
	"ere utilizzato solo dagli utenti membri del gruppo %[1]s di sistema.\x02" +
	"WireGuard è in esecuzione, ma l'interfaccia utente è accessibile solo da" +
	"i desktop del gruppo %[1]s di sistema.\x02L'icona della barra delle appl" +
	"icazioni di WireGuard non è apparsa dopo 30 secondi.\x02Ora\x02L'orologi" +
	"o di sistema va all'indietro!\x14\x01\x81\x01\x00\x02\x0b\x02%[1]d anno" +
	"\x00\x0b\x02%[1]d anni\x14\x01\x81\x01\x00\x02\x0d\x02%[1]d giorno\x00" +
	"\x0d\x02%[1]d giorni\x14\x01\x81\x01\x00\x02\x0a\x02%[1]d ora\x00\x0a" +
	"\x02%[1]d ore\x14\x01\x81\x01\x00\x02\x0d\x02%[1]d minuto\x00\x0d\x02%[1" +
	"]d minuti\x14\x01\x81\x01\x00\x02\x0e\x02%[1]d secondo\x00\x0e\x02%[1]d " +
	"secondi\x02%[1]s fa\x02%[1]d\u00a0B\x02%.2[1]f\u00a0KiB\x02%.2[1]f\u00a0" +
	"MiB\x02%.2[1]f\u00a0GiB\x02%.2[1]f\u00a0TiB\x02%[1]s: %[2]q\x02Indirizzo" +
	" IP non valido\x02Lunghezza del prefisso di rete non valida\x02Manca la " +
	"porta dall'endpoint\x02Host dell'endpoint non valido\x02Le parentesi dev" +
	"ono contenere un indirizzo IPv6\x02MTU non valido\x02Porta non valida" +
	"\x02Keepalive permanente non valido\x02Chiave non valida: %[1]v\x02Le ch" +
	"iavi devono decodificare esattamente 32 byte\x02Il numero deve essere un" +
	" numero compreso tra 0 e 2^64-1: %[1]v\x02Due virgole in una riga\x02Il " +
	"nome del tunnel non è valido\x02Una riga deve essere presente in una sez" +
	"ione\x02La chiave deve avere un valore\x02Chiave non valida per la sezio" +
	"ne [Interface]\x02Chiave non valida per la sezione [Peer]\x02Un'interfac" +
	"cia deve avere una chiave privata\x02[non specificato]\x02Tutti i peer d" +
	"evono avere una chiave pubblica\x02Errore durante il recupero della conf" +
	"igurazione\x02Chiave non valida per la sezione dell'interfaccia\x02La ve" +
	"rsione del protocollo deve essere 1\x02Chiave non valida per la sezione " +
	"peer\x02, \x02 \x02Informazioni su WireGuard\x02Immagine del logo di Wir" +
	"eGuard\x02Versione applicazione: %[1]s\x0aVersione backend Go: %[2]s\x0a" +
	"Versione Go: %[3]s\x0aSistema operativo: %[4]s\x0aArchitettura: %[5]s" +
	"\x02Chiudi\x02♥ Fai una &donazione!\x02Stato:\x02&Disattiva\x02&Attiva" +
	"\x02Chiave pubblica:\x02Porta in ascolto:\x02MTU:\x02Indirizzi:\x02Serve" +
	"r DNS:\x02Chiave pre-condivisa:\x02IP consentiti:\x02Endpoint:\x02Keepal" +
	"ive permanente:\x02Ultima negoziazione:\x02Trasferimento:\x02abilitato" +
	"\x02%[1]s ricevuti, %[2]s inviati\x02Determinazione dello stato del tunn" +
	"el non riuscita\x02Attivazione del tunnel non riuscita\x02Disattivazione" +
	" del tunnel non riuscita\x02Interfaccia: %[1]s\x02Peer\x02Crea tunnel" +
	"\x02Modifica tunnel\x02&Nome:\x02Chiave &pubblica:\x02(sconosciuto)\x02&" +
	"Blocca traffico fuori dal tunnel (kill-switch)\x02Quando una configurazi" +
	"one ha esattamente un peer e quel peer ha un IP consentito contenente al" +
	"meno uno di 0.0.0.0/0 o ::/0, il servizio tunnel impegna un insieme di r" +
	"egole del firewall per bloccare tutto il traffico che non proviene dall'" +
	"interfaccia tunnel, con speciali eccezioni per DHCP e NDP.\x02&Salva\x02" +
	"Annulla\x02&Configurazione:\x02Nome non valido\x02Un nome è richiesto." +
	"\x02Il nome del tunnel ‘%[1]s’ non è valido.\x02Impossibile elencare i t" +
	"unnel esistenti\x02Il tunnel esiste già\x02Un altro tunnel con il nome ‘" +
	"%[1]s’ esiste già.\x02Impossibile creare la nuova configurazione\x02Scri" +
	"ttura del file non riuscita\x02Il file ‘%[1]s’ esiste già.\x0a\x0aVuoi s" +
	"ovrascriverlo?\x02Attivo\x02Attivazione\x02Inattivo\x02Disattivazione" +
	"\x02Stato sconosciuto\x02Log\x02&Copia\x02Selezion&a tutto\x02&Salva su " +
	"file…\x02Tempo\x02Messaggio di log\x02File di testo (*.txt)|*.txt|Tutti " +
	"i file (*.*)|*.*\x02Esporta log su file\x02Inform&azioni su WireGuard…" +
	"\x02Errore del tunnel\x02%[1]s\x0a\x0aConsulta il log per ulteriori Info" +
	"rmazioni.\x02%[1]s (obsoleto)\x02Errore di rilevamento di WireGuard\x02I" +
	"mpossibile attendere la comparsa della finestra di WireGuard: %[1]v\x02W" +
	"ireGuard: disattivato\x02Stato: sconosciuto\x02Indirizzi: nessuno\x02&Ge" +
	"stisci i tunnel…\x02&Importa tunnel da file…\x02E&sci\x02Errore tunnel d" +
	"i WireGuard\x02WireGuard: %[1]s\x02Stato: %[1]s\x02Indirizzi: %[1]s\x02W" +
	"ireGuard attivato\x02Il tunnel %[1]s è stato attivato.\x02WireGuard disa" +
	"ttivato\x02Il tunnel %[1]s è stato disattivato.\x02Un aggiornamento è di" +
	"sponibile!\x02Aggiornamento di WireGuard disponibile\x02Un aggiornamento" +
	" di WireGuard è disponibile. Ti consigliamo di aggiornare il prima possi" +
	"bile.\x02Tunnel\x02&Modifica\x02Aggiungi tunn&el vuoto\x02Aggiungi tunne" +
	"l\x02Rimuovi tunnel selezionati\x02Esporta tutti i tunnel in zip\x02Comm" +
	"u&ta\x02Esporta tutti i tunnel in &zip\x02Modifica il tunnel &selezionat" +
	"o…\x02&Rimuovi i tunnel selezionati\x02Impossibile importare la configur" +
	"azione selezionata: %[1]v\x02Impossibile enumerare i tunnel esistenti: %" +
	"[1]v\x02Un altro tunnel esiste già con il nome ‘%[1]s‘\x02Impossibile im" +
	"portare la configurazione: %[1]v\x02Tunnel importati\x14\x01\x81\x01\x00" +
	"\x02\x17\x02%[1]d tunnel importato\x00\x17\x02%[1]d tunnel importati\x14" +
	"\x02\x80\x01\x02 \x02%[1]d de %[2]d tunnel importato\x00 \x02%[1]d di %[" +
	"2]d tunnel importati\x02Impossibile creare il tunnel\x14\x01\x81\x01\x00" +
	"\x02\x15\x02Elimina %[1]d tunnel\x00\x15\x02Elimina %[1]d tunnel\x14\x01" +
	"\x81\x01\x00\x02,\x02Sei sicuro di voler eliminare %[1]d tunnel?\x00," +
	"\x02Sei sicuro di voler eliminare %[1]d tunnel?\x02Elimina tunnel ‘%[1]s" +
	"‘\x02Sei sicuro di voler eliminare il tunnel ‘%[1]s‘?\x02%[1]s Non è p" +
	"ossibile annullare questa azione.\x02Impossibile eliminare il tunnel\x02" +
	"Non è stato possibile rimuovere un tunnel: %[1]s\x02Impossibile eliminar" +
	"e i tunnel\x14\x01\x81\x01\x00\x02/\x02Non è stato possibile eliminare %" +
	"[1]d tunnel.\x00/\x02Non è stato possibile eliminare %[1]d tunnel.\x02Fi" +
	"le di configurazione (*.zip, *.conf)|*.zip;*.conf|Tutti i file (*.*)|*.*" +
	"\x02Importa tunnel da file\x02File di configurazione ZIP (*.zip)|*.zip" +
	"\x02Esporta tunnel in zip\x02%[1]s (versione non firmata, nessun aggiorn" +
	"amento)\x02Errore durante la chiusura di WireGuard\x02Impossibile uscire" +
	" dal servizio a causa di: %[1]v. Potresti voler interrompere WireGuard d" +
	"al gestore dei servizi.\x02Un aggiornamento di WireGuard è disponibile. " +
	"Ti consigliamo vivamente di aggiornare immediatamente.\x02Stato: in atte" +
	"sa dell'utente\x02Aggiorna ora\x02Stato: in attesa del servizio di aggio" +
	"rnamento\x02Errore: %[1]v. Prova ancora.\x02Stato: Completo!\x02http2: F" +
	"ramer %[1]p: decodifica del frame appena scritto non riuscita\x02http2: " +
	"Framer %[1]p: ha scritto %[2]v\x02http2: Framer %[1]p: ha letto %[2]v" +
	"\x02http2: campo hpack %+[1]v decodificato"

var jaIndex = []uint32{ // 177 elements
	// Entry 0 - 1F
	0x00000000, 0x0000000a, 0x0000005b, 0x00000075,
	0x0000009a, 0x000000e6, 0x0000013c, 0x0000017a,
	0x000001d1, 0x00000254, 0x000002a9, 0x000002ad,
	0x000002d5, 0x000002e6, 0x000002f7, 0x0000030b,
	0x0000031c, 0x0000032d, 0x00000337, 0x0000033f,
	0x0000034c, 0x00000359, 0x00000366, 0x00000373,
	0x00000380, 0x0000039a, 0x000003ce, 0x000003fc,
	0x00000424, 0x00000455, 0x00000463, 0x0000047c,
	// Entry 20 - 3F
	0x000004a7, 0x000004bb, 0x000004ed, 0x00000540,
	0x00000564, 0x00000583, 0x000005ae, 0x000005e5,
	0x00000616, 0x0000064b, 0x0000067b, 0x000006b2,
	0x000006c1, 0x000006f2, 0x00000726, 0x00000759,
	0x0000079c, 0x000007ca, 0x000007cd, 0x000007cf,
	0x000007e6, 0x000007fd, 0x00000868, 0x00000872,
	0x0000088e, 0x00000896, 0x000008a4, 0x000008b2,
	0x000008bd, 0x000008d4, 0x000008d9, 0x000008e7,
	// Entry 40 - 5F
	0x000008f6, 0x00000907, 0x00000914, 0x0000092b,
	0x0000094b, 0x0000096b, 0x00000973, 0x0000097a,
	0x000009a2, 0x000009d3, 0x00000a01, 0x00000a2f,
	0x00000a4f, 0x00000a56, 0x00000a72, 0x00000a88,
	0x00000a94, 0x00000aa3, 0x00000aac, 0x00000b05,
	0x00000c39, 0x00000c44, 0x00000c54, 0x00000c60,
	0x00000c70, 0x00000c89, 0x00000cb8, 0x00000ce6,
	0x00000d0e, 0x00000d5d, 0x00000d8e, 0x00000db3,
	// Entry 60 - 7F
	0x00000e05, 0x00000e0c, 0x00000e19, 0x00000e20,
	0x00000e2d, 0x00000e3d, 0x00000e44, 0x00000e52,
	0x00000e66, 0x00000e83, 0x00000e8a, 0x00000ea1,
	0x00000eeb, 0x00000f16, 0x00000f33, 0x00000f49,
	0x00000f7e, 0x00000f93, 0x00000fad, 0x00000fef,
	0x0000100a, 0x00001019, 0x0000102e, 0x0000104b,
	0x00001083, 0x0000108e, 0x000010ae, 0x000010bf,
	0x000010cd, 0x000010e1, 0x000010fb, 0x0000112d,
	// Entry 80 - 9F
	0x00001147, 0x00001179, 0x00001198, 0x000011c1,
	0x00001229, 0x00001236, 0x00001241, 0x00001264,
	0x0000127a, 0x0000129c, 0x000012d0, 0x000012e1,
	0x0000131c, 0x00001345, 0x0000136b, 0x000013b8,
	0x000013f6, 0x00001442, 0x0000147a, 0x0000149f,
	0x000014d7, 0x0000151b, 0x00001540, 0x00001563,
	0x0000159f, 0x000015c2, 0x000015fd, 0x0000162e,
	0x00001653, 0x00001688, 0x000016ad, 0x000016e8,
	// Entry A0 - BF
	0x0000173b, 0x0000176c, 0x00001796, 0x000017be,
	0x000017f4, 0x0000180e, 0x00001892, 0x000018f7,
	0x00001921, 0x00001931, 0x00001964, 0x00001999,
	0x000019ab, 0x000019f1, 0x00001a25, 0x00001a59,
	0x00001a99,
} // Size: 732 bytes

const jaData string = "" + // Size: 6809 bytes
	"\x02エラー\x02(引数なし): 管理者権限でmanagerサービスをインストールする\x02使い方: %[1]s [\x0a%[2]s]" +
	"\x02コマンドラインオプション\x02プロセスがWOW64下で動作しているか確認できません: %[1]v\x02このコンピュータでは64ビット" +
	"版の WireGuard を使ってください。\x02現在のプロセスのトークンを開けません: %[1]v\x02WireGuard は組み込み" +
	"の %[1]s グループのメンバーだけが使えます。\x02WireGuard は実行中ですが、UI画面は組み込みの %[1]s グループのデ" +
	"スクトップからしか開けません。\x02WireGuard システムトレイアイコンは30秒後に非表示になります。\x02今\x02システム時刻" +
	"が巻き戻った！\x14\x01\x81\x01\x00\x00\x0a\x02%[1]d 年\x14\x01\x81\x01\x00\x00" +
	"\x0a\x02%[1]d 日\x14\x01\x81\x01\x00\x00\x0d\x02%[1]d 時間\x14\x01\x81\x01" +
	"\x00\x00\x0a\x02%[1]d 分\x14\x01\x81\x01\x00\x00\x0a\x02%[1]d 秒\x02%[1]s " +
	"前\x02%[1]d B\x02%.2[1]f\u00a0KiB\x02%.2[1]f\u00a0MiB\x02%.2[1]f\u00a0G" +
	"iB\x02%.2[1]f\u00a0TiB\x02%[1]s: %[2]q\x02無効な IP アドレス\x02無効なネットワークプレフィック" +
	"ス長\x02エンドポイントのポート指定なし\x02無効なエンドポイントホスト\x02カッコ内は IPv6 アドレスが入ります\x02無効な " +
	"MTU\x02無効なポート番号\x02無効な持続的キープアライブ値\x02不正な鍵: %[1]v\x02鍵は 32 バイトでなければなりません" +
	"\x02数値は0から2の64乗-1の範囲内の値でなければなりません: %[1]v\x021行にカンマが2つあります\x02トンネル名が不正です" +
	"\x02行がセクション内にありません\x02設定項目にイコール(=)セパレータがない\x02キー項目に対応する値がありません\x02無効な [I" +
	"nterface] セクションのキー項目\x02無効な [Peer] セクションのキー項目\x02インターフェースには秘密鍵が必須です\x02[" +
	"指定なし]\x02すべてのピアには公開鍵が必須です\x02設定の読込中にエラーが発生しました\x02無効な Interface セクションの" +
	"キー項目\x02プロトコルバージョンは 1 でなければなりません\x02無効な Peer セクションのキー項目\x02, \x02 \x02" +
	"WireGuard について\x02WireGuard ロゴ画像\x02App version: %[1]s\x0aGo backend ver" +
	"sion: %[2]s\x0aGo version: %[3]s\x0aOperating system: %[4]s\x0aArchitect" +
	"ure: %[5]s\x02閉じる\x02♥ 寄付のお願い!(&D)\x02状態:\x02無効化(&D)\x02有効化(&A)\x02公開鍵:" +
	"\x02待受ポート番号:\x02MTU:\x02アドレス:\x02DNS サーバ:\x02事前共有鍵:\x02Allowed IPs:\x02エ" +
	"ンドポイント:\x02持続的キープアライブ:\x02直近のハンドシェイク:\x02転送:\x02有効\x02%[1]s 受信済み、%[2]s" +
	" 送信済み\x02トンネルの状態取得に失敗しました\x02トンネルの有効化に失敗しました\x02トンネルの無効化に失敗しました\x02インターフ" +
	"ェース: %[1]s\x02ピア\x02トンネルの新規作成\x02トンネルの編集\x02名前(&N):\x02公開鍵(&P):\x02(不明" +
	")\x02トンネルを通らないトラフィックのブロック（キルスイッチ）(&B)\x02ピアが1つだけ設定されていて、さらに Allowed IPs " +
	"に 0.0.0.0/0 または ::/0 が含まれている場合、トンネルサービスはトンネルインターフェースを通らないすべてのトラフィックをブロ" +
	"ックするファイアウォールルールを追加します。\x02保存(&S)\x02キャンセル\x02設定(&C):\x02無効な名前\x02名前は必須" +
	"です。\x02トンネル名 ‘%[1]s’ は不正です。\x02既存のトンネルを表示できません\x02トンネルはすでに存在します\x02‘%[" +
	"1]s’ という名前の別のトンネルがすでに存在します。\x02新しい設定を作成できませんでした\x02ファイルの書き込みに失敗\x02ファイル " +
	"‘%[1]s’ はすでに存在します。\x0a\x0a上書きしますか？\x02有効\x02有効化中\x02無効\x02無効化中\x02不明な状" +
	"態\x02ログ\x02コピー(&C)\x02すべて選択(&A)\x02ファイルに保存…(&S)\x02時刻\x02ログ メッセージ\x02テ" +
	"キストファイル (*.txt)|*.txt|すべてのファイル (*.*)|*.*\x02ログをファイルにエクスポート\x02WireGuar" +
	"dについて…(&A)\x02トンネルエラー\x02%[1]s\x0a\x0a詳細はログを参照してください。\x02%[1]s (更新あり)" +
	"\x02WireGuard 検出エラー\x02WireGuard ウィンドウが表示できませんでした: %[1]v\x02WireGuard: 無" +
	"効化済み\x02状態: 不明\x02アドレス: なし\x02トンネルの管理…(&M)\x02トンネルをファイルからインポート…(&I)" +
	"\x02終了(&X)\x02WireGuard トンネルエラー\x02WireGuard: %[1]s\x02状態: %[1]s\x02アドレス" +
	": %[1]s\x02WireGuard 有効化済み\x02トンネル %[1]s は有効になりました。\x02WireGuard 無効化済み" +
	"\x02トンネル %[1]s は無効になりました。\x02更新が利用できます！\x02WireGuard の更新が利用可能です\x02WireG" +
	"uard の更新が利用可能になりました。できるだけ早く更新してください。\x02トンネル\x02編集(&E)\x02空のトンネルを追加…(&E)" +
	"\x02トンネルの追加\x02選択したトンネルの削除\x02すべてのトンネルをzipにエクスポート\x02切り替え(&T)\x02すべてのトンネ" +
	"ルをzipにエクスポート…(&Z)\x02選択したトンネルの編集…(&S)\x02選択したトンネルの削除(&R)\x02選択したファイルから" +
	"インポートできませんでした: %[1]v\x02既存のトンネルを表示できませんでした: %[1]v\x02‘%[1]s’ という名前の別のト" +
	"ンネルがすでに存在します\x02設定をインポートできませんでした: %[1]v\x02トンネルのインポート結果\x14\x01\x81" +
	"\x01\x00\x001\x02%[1]d トンネルをインポートしました\x14\x02\x80\x01\x00>\x02%[2]d 中の %" +
	"[1]d トンネルをインポートしました\x02トンネルを作成できません\x14\x01\x81\x01\x00\x00\x1c\x02%[1]d" +
	" トンネルを削除\x14\x01\x81\x01\x00\x005\x02本当に %[1]d トンネルを削除しますか？\x02トンネル ‘%[1" +
	"]s’ を削除\x02本当にトンネル ‘%[1]s’ を削除しますか？\x02%[1]s この操作はもとに戻せません。\x02トンネルを削除でき" +
	"ません\x02トンネルを削除できませんでした: %[1]s\x02トンネルを削除できません\x14\x01\x81\x01\x00\x004" +
	"\x02%[1]d トンネルを削除できませんでした\x02設定ファイル (*.zip, *.conf)|*.zip;*.conf|すべてのファイ" +
	"ル (*.*)|*.*\x02ファイルからトンネルをインポート\x02ZIP形式設定ファイル (*.zip)|*.zip\x02トンネルをZ" +
	"IPにエクスポート\x02%[1]s (未署名のビルド、更新の提供なし)\x02WireGuard 終了エラー\x02%[1]v のためサービス" +
	"を終了できませんでした。サービスマネージャから WireGuard を停止できます。\x02WireGuard の更新が利用可能です。速やか" +
	"に更新することを強く推奨します。\x02状態: ユーザーからの応答待ち\x02今すぐ更新\x02状態: アップデータサービスを待機中\x02" +
	"エラー: %[1]v。再度実行してください。\x02状態: 完了！\x02http2: Framer %[1]p: just-written" +
	"フレームのデコードに失敗\x02http2: Framer %[1]p: %[2]v を書き込みました\x02http2: Framer %" +
	"[1]p: %[2]v を読み込みました\x02http2: hpack フィールド %+[1]v をデコードしました"

var plIndex = []uint32{ // 177 elements
	// Entry 0 - 1F
	0x00000000, 0x00000007, 0x00000007, 0x00000007,
	0x0000001e, 0x0000001e, 0x0000005b, 0x0000005b,
	0x0000005b, 0x0000005b, 0x0000005b, 0x0000005b,
	0x0000005b, 0x0000005b, 0x0000005b, 0x0000005b,
	0x0000005b, 0x0000005b, 0x0000005b, 0x0000005b,
	0x0000005b, 0x0000005b, 0x0000005b, 0x0000005b,
	0x0000005b, 0x0000005b, 0x0000005b, 0x0000005b,
	0x0000005b, 0x0000005b, 0x0000005b, 0x0000005b,
	// Entry 20 - 3F
	0x0000005b, 0x0000005b, 0x0000005b, 0x0000005b,
	0x0000005b, 0x0000005b, 0x0000005b, 0x0000005b,
	0x0000005b, 0x0000005b, 0x0000005b, 0x0000005b,
	0x0000005b, 0x0000005b, 0x0000005b, 0x0000005b,
	0x0000005b, 0x0000005b, 0x0000005b, 0x0000005b,
	0x0000005b, 0x0000005b, 0x0000005b, 0x0000005b,
	0x0000005b, 0x0000005b, 0x0000005b, 0x0000005b,
	0x0000005b, 0x0000005b, 0x0000005b, 0x0000005b,
	// Entry 40 - 5F
	0x0000005b, 0x0000005b, 0x0000005b, 0x0000005b,
	0x0000005b, 0x0000005b, 0x0000005b, 0x0000005b,
	0x0000005b, 0x0000005b, 0x0000005b, 0x0000005b,
	0x0000005b, 0x0000005b, 0x0000005b, 0x0000005b,
	0x0000005b, 0x0000005b, 0x0000005b, 0x0000005b,
	0x0000005b, 0x0000005b, 0x0000005b, 0x0000005b,
	0x0000005b, 0x0000005b, 0x0000005b, 0x0000005b,
	0x0000005b, 0x0000005b, 0x0000005b, 0x0000005b,
	// Entry 60 - 7F
	0x0000005b, 0x0000005b, 0x0000005b, 0x0000005b,
	0x0000005b, 0x0000005b, 0x0000005b, 0x0000005b,
	0x0000005b, 0x0000005b, 0x0000005b, 0x0000005b,
	0x0000005b, 0x0000005b, 0x0000005b, 0x0000005b,
	0x0000005b, 0x0000005b, 0x0000005b, 0x0000005b,
	0x0000005b, 0x0000005b, 0x0000005b, 0x0000005b,
	0x0000005b, 0x0000005b, 0x0000005b, 0x0000005b,
	0x0000005b, 0x0000005b, 0x0000005b, 0x0000005b,
	// Entry 80 - 9F
	0x0000005b, 0x0000005b, 0x0000005b, 0x0000005b,
	0x0000005b, 0x0000005b, 0x0000005b, 0x0000005b,
	0x0000005b, 0x0000005b, 0x0000005b, 0x0000005b,
	0x0000005b, 0x0000005b, 0x0000005b, 0x0000005b,
	0x0000005b, 0x0000005b, 0x0000005b, 0x0000005b,
	0x0000005b, 0x0000005b, 0x0000005b, 0x0000005b,
	0x0000005b, 0x0000005b, 0x0000005b, 0x0000005b,
	0x0000005b, 0x0000005b, 0x0000005b, 0x0000005b,
	// Entry A0 - BF
	0x0000005b, 0x0000005b, 0x0000005b, 0x0000005b,
	0x0000005b, 0x0000005b, 0x0000005b, 0x0000005b,
	0x0000005b, 0x0000005b, 0x0000005b, 0x0000005b,
	0x0000005b, 0x0000005b, 0x0000005b, 0x0000005b,
	0x0000005b,
} // Size: 732 bytes

const plData string = "" + // Size: 91 bytes
	"\x02Błąd\x02Opcje wiersza poleceń\x02Musisz użyć 64-bitowej wersji WireG" +
	"uard na tym komputerze."

var roIndex = []uint32{ // 177 elements
	// Entry 0 - 1F
	0x00000000, 0x00000007, 0x0000005d, 0x00000077,
	0x00000092, 0x000000d1, 0x0000011e, 0x00000152,
	0x000001b6, 0x00000232, 0x0000027c, 0x00000281,
	0x000002a8, 0x000002d3, 0x00000300, 0x0000032d,
	0x00000361, 0x0000039a, 0x000003a5, 0x000003ae,
	0x000003bb, 0x000003c8, 0x000003d5, 0x000003e2,
	0x000003ef, 0x00000404, 0x00000431, 0x00000456,
	0x00000479, 0x000004aa, 0x000004b8, 0x000004c5,
	// Entry 20 - 3F
	0x000004e8, 0x000004ff, 0x00000544, 0x00000580,
	0x000005a2, 0x000005c1, 0x000005ec, 0x00000633,
	0x00000659, 0x00000687, 0x000006b0, 0x000006e1,
	0x000006f8, 0x00000727, 0x0000074b, 0x00000779,
	0x000007a1, 0x000007cc, 0x000007cf, 0x000007d2,
	0x000007e3, 0x000007fc, 0x00000885, 0x00000890,
	0x0000089f, 0x000008a6, 0x000008b3, 0x000008bd,
	0x000008cd, 0x000008e0, 0x000008e5, 0x000008ed,
	// Entry 40 - 5F
	0x000008fa, 0x00000911, 0x00000921, 0x0000092e,
	0x0000094a, 0x00000967, 0x00000974, 0x0000097e,
	0x00000999, 0x000009c5, 0x000009e3, 0x00000a04,
	0x00000a17, 0x00000a1f, 0x00000a30, 0x00000a3e,
	0x00000a45, 0x00000a56, 0x00000a65, 0x00000ab2,
	0x00000c4e, 0x00000c57, 0x00000c5f, 0x00000c6f,
	0x00000c7c, 0x00000c92, 0x00000cbd, 0x00000ce4,
	0x00000cf9, 0x00000d2a, 0x00000d4f, 0x00000d6d,
	// Entry 60 - 7F
	0x00000db3, 0x00000db9, 0x00000dc7, 0x00000dcf,
	0x00000de0, 0x00000df3, 0x00000dfa, 0x00000e03,
	0x00000e16, 0x00000e2e, 0x00000e33, 0x00000e43,
	0x00000e7a, 0x00000e97, 0x00000eac, 0x00000ebc,
	0x00000ef4, 0x00000f09, 0x00000f27, 0x00000f65,
	0x00000f7b, 0x00000f8f, 0x00000f9f, 0x00000fb7,
	0x00000fdc, 0x00000fe5, 0x00000fff, 0x00001010,
	0x0000101d, 0x0000102b, 0x0000103d, 0x0000105b,
	// Entry 80 - 9F
	0x00001070, 0x00001091, 0x000010b2, 0x000010dc,
	0x00001152, 0x0000115b, 0x00001164, 0x0000117c,
	0x0000118c, 0x000011ad, 0x000011cf, 0x000011d9,
	0x000011ff, 0x0000121a, 0x0000123c, 0x00001275,
	0x000012aa, 0x000012da, 0x00001306, 0x00001319,
	0x0000136c, 0x000013dc, 0x000013f6, 0x0000144c,
	0x000014f6, 0x00001512, 0x0000154c, 0x0000157a,
	0x00001595, 0x000015bc, 0x000015d9, 0x0000165d,
	// Entry A0 - BF
	0x000016ad, 0x000016ce, 0x000016f8, 0x00001713,
	0x00001744, 0x00001765, 0x000017c6, 0x00001823,
	0x00001845, 0x00001856, 0x00001884, 0x000018a7,
	0x000018bb, 0x000018fd, 0x00001920, 0x00001943,
	0x00001969,
} // Size: 732 bytes

const roData string = "" + // Size: 6505 bytes
	"\x02Eroare\x02(fără argument): obținere drept administrativ și instalare" +
	" serviciu de gestionare\x02Utilizare: %[1]s [\x0a%[2]s]\x02Opțiuni linie" +
	" de comandă\x02Nu se poate determina dacă procesul rulează sub WOW64: %[" +
	"1]v\x02Trebuie să utilizezi versiunea de 64 biți a WireGuard pe acest ca" +
	"lculator.\x02Nu poate fi deschis tokenul actual de proces: %[1]v\x02Wire" +
	"Guard poate fi utilizat doar de către utilizatorii care sunt membri ai g" +
	"rupului Builtin %[1]s.\x02WireGuard rulează, dar interfața cu utilizator" +
	"ul este accesibilă doar din spațiile de lucru ale grupului Builtin %[1]s" +
	".\x02Pictograma WireGuard din bara de sistem nu a apărut după 30 de secu" +
	"nde.\x02Acum\x02Ceasul de sistem a fost dat în spate!\x14\x01\x81\x01" +
	"\x00\x04\x0a\x02%[1]d ani\x02\x09\x02%[1]d an\x00\x0d\x02%[1]d de ani" +
	"\x14\x01\x81\x01\x00\x04\x0b\x02%[1]d zile\x02\x09\x02%[1]d zi\x00\x0e" +
	"\x02%[1]d de zile\x14\x01\x81\x01\x00\x04\x0a\x02%[1]d ore\x02\x0b\x02%[" +
	"1]d oră\x00\x0d\x02%[1]d de ore\x14\x01\x81\x01\x00\x04\x0d\x02%[1]d min" +
	"ute\x02\x0c\x02%[1]d minut\x00\x10\x02%[1]d de minute\x14\x01\x81\x01" +
	"\x00\x04\x0e\x02%[1]d secunde\x02\x0f\x02%[1]d secundă\x00\x11\x02%[1]d " +
	"de secunde\x02acum %[1]s\x02%[1]d\u00a0B\x02%.2[1]f\u00a0KiB\x02%.2[1]f" +
	"\u00a0MiB\x02%.2[1]f\u00a0GiB\x02%.2[1]f\u00a0TiB\x02%[1]s: %[2]q\x02Adr" +
	"esă IP invalidă\x02Lungimea prefixului de rețea este invalidă\x02Lipseșt" +
	"e portul de la punctul final\x02Gazdă invalidă a punctului final\x02Para" +
	"ntezele trebuie să conțină o adresă IPv6\x02MTU invalidă\x02Port invalid" +
	"\x02Mesaj keepalive persistent invalid\x02Cheie invalidă: %[1]v\x02Rezul" +
	"tatul decodificat de chei trebuie să aibă exact 32 de octeți\x02Numărul " +
	"trebuie să fie cuprins între 0 și 2^64-1: %[1]v\x02Două virgule una după" +
	" cealaltă\x02Numele tunelului nu este valid\x02Linia trebuie să apară în" +
	"tr-o secțiune\x02Cheii de configurare îi lipsește un separator de forma " +
	"semnului egal\x02Cheia trebuie să conțină o valoare\x02Cheie invalidă pe" +
	"ntru secțiunea [Interface]\x02Cheie invalidă pentru secțiunea [Peer]\x02" +
	"O interfață trebuie să aibă o cheie privată\x02[niciuna specificată]\x02" +
	"Toate perechile trebuie să aibă chei publice\x02Eroare la obținerea conf" +
	"igurației\x02Cheie invalidă pentru secțiunea interfeței\x02Versiunea de " +
	"protocol trebuie să fie 1\x02Cheie invalidă pentru secțiunea perechii" +
	"\x02, \x02, \x02Despre WireGuard\x02Imagine siglă WireGuard\x02Versiunea" +
	" aplicației: %[1]s\x0aVersiunea bibliotecii subiacente Go: %[2]s\x0aVers" +
	"iunea Go: %[3]s\x0aSistem de operare: %[4]s\x0aArhitectură: %[5]s\x02Înc" +
	"hidere\x02♥ &Donează!\x02Stare:\x02&Dezactivare\x02&Activare\x02Cheie pu" +
	"blică:\x02Port de ascultare:\x02MTU:\x02Adrese:\x02Servere DNS:\x02Cheie" +
	" predistribuită:\x02IP-uri permise:\x02Punct final:\x02Mesaj keepalive p" +
	"ersistent:\x02Ultimul acord de interogare:\x02Transferare:\x02activată" +
	"\x02%[1]s primit, %[2]s trimis\x02Nu a putut fi determinată starea tunel" +
	"ului\x02Tunelul nu a putut fi activat\x02Tunelul nu a putut fi dezactiva" +
	"t\x02Interfață: %[1]s\x02Pereche\x02Creare tunel nou\x02Editare tunel" +
	"\x02&Nume:\x02Cheie &publică:\x02(necunoscută)\x02&Blochează traficul ca" +
	"re nu trece prin tunel (întrerupător de activitate)\x02Când o configuraț" +
	"ie conține exact o pereche, iar acea pereche are IP-uri permise care con" +
	"țin cel puțin o variantă dintre 0.0.0.0/0 sau ::/0, atunci serviciul tu" +
	"nelului activează un set de reguli al paravanului de protecție pentru a " +
	"bloca întregul trafic care nu provine de la interfața tunelului, precum " +
	"și întregul trafic direcționat spre aceasta, existând excepții speciale" +
	" pentru DHCP și NDP.\x02&Salvare\x02Anulare\x02&Configurație:\x02Nume in" +
	"valid\x02Este necesar un nume.\x02Numele tunelului „%[1]s” este invalid." +
	"\x02Tunelurile existente nu pot fi listate\x02Tunelul există deja\x02Exi" +
	"stă deja un alt tunel cu numele „%[1]s”.\x02Nu se poate crea configurați" +
	"a nouă\x02Scrierea fișierului a eșuat\x02Fișierul „%[1]s” există deja." +
	"\x0a\x0aDorești suprascrierea acestuia?\x02Activ\x02Se activează\x02Inac" +
	"tiv\x02Se dezactivează\x02Stare necunoscută\x02Jurnal\x02&Copiere\x02Sel" +
	"ectare &totală\x02&Salvare în fișier…\x02Timp\x02Mesaj de jurnal\x02Fiși" +
	"ere text (*.txt)|*.txt|Toate fișierele (*.*)|*.*\x02Exportare jurnal în " +
	"fișier\x02&Despre WireGuard…\x02Eroare de tunel\x02%[1]s\x0a\x0aConsultă" +
	" jurnalul pentru mai multe informații.\x02%[1]s (neactualizat)\x02Eroare" +
	" de detectare WireGuard\x02Nu se poate aștepta ca fereastra WireGuard să" +
	" apară: %[1]v\x02WireGuard: dezactivat\x02Stare: necunoscută\x02Adrese: " +
	"niciuna\x02&Gestionare tuneluri…\x02&Importare tunel(uri) din fișier…" +
	"\x02Ie&șire\x02Eroare de tunel WireGuard\x02WireGuard: %[1]s\x02Stare: %" +
	"[1]s\x02Adrese: %[1]s\x02WireGuard activat\x02Tunelul %[1]s a fost activ" +
	"at.\x02WireGuard dezactivat\x02Tunelul %[1]s a fost dezactivat.\x02Este " +
	"disponibilă o actualizare!\x02Actualizare disponibilă pentru WireGuard" +
	"\x02O actualizare pentru WireGuard este acum disponibilă. Se recomandă e" +
	"fectuarea actualizării cât mai rapid posibil.\x02Tuneluri\x02%Editare" +
	"\x02Adăugare tunel &gol…\x02Adăugare tunel\x02Eliminare tunel(uri) selec" +
	"tat(e)\x02Exportă toate tunelurile în zip\x02&Comutare\x02Exportă toate " +
	"tunelurile în &zip…\x02Editare tunel &selectat…\x02&Eliminare tunel(uri)" +
	" selectat(e)\x02Configurația selectată nu a putut fi importată: %[1]v" +
	"\x02Tunelurile existente nu au putut fi enumerate: %[1]v\x02Există deja " +
	"un alt tunel cu numele „%[1]s”\x02Configurația nu poate fi importată: %[" +
	"1]v\x02Tuneluri importate\x14\x01\x81\x01\x00\x04\x18\x02Importat %[1]d " +
	"tuneluri\x02\x15\x02Importat %[1]d tunel\x00\x1b\x02Importat %[1]d de tu" +
	"neluri\x14\x02\x80\x01\x04\x22\x02Importat %[1]d din %[2]d tuneluri\x02" +
	"\x1f\x02Importat %[1]d din %[2]d tunel\x00%\x02Importat %[1]d din %[2]d " +
	"de tuneluri\x02Tunelul nu poate fi creat\x14\x01\x81\x01\x00\x04\x19\x02" +
	"Ștergere %[1]d tuneluri\x02\x16\x02Ștergere %[1]d tunel\x00\x1c\x02Șter" +
	"gere %[1]d de tuneluri\x14\x01\x81\x01\x00\x045\x02Ești sigur că dorești" +
	" să ștergi %[1]d tuneluri?\x022\x02Ești sigur că dorești să ștergi %[1]d" +
	" tunel?\x008\x02Ești sigur că dorești să ștergi %[1]d de tuneluri?\x02Șt" +
	"ergere tunel „%[1]s”\x02Ești sigur că dorești să ștergi tunelul „%[1]s”?" +
	"\x02%[1]s Această acțiune nu poate fi anulată.\x02Tunelul nu poate fi șt" +
	"ers\x02Un tunel nu a putut fi eliminat: %[1]s\x02Nu se pot șterge tunelu" +
	"rile\x14\x01\x81\x01\x00\x04)\x02%[1]d tuneluri nu au putut fi eliminate" +
	".\x02$\x02%[1]d tunel nu a putut fi eliminat.\x00,\x02%[1]d de tuneluri " +
	"nu au putut fi eliminate.\x02Fișiere de configurare (*.zip, *.conf)|*.zi" +
	"p;*.conf|Toate fișierele (*.*)|*.*\x02Importare tunel(uri) din fișier" +
	"\x02Fișiere ZIP de configurare (*.zip)|*.zip\x02Exportare tuneluri în zi" +
	"p\x02%[1]s (versiune nesemnată, fără actualizări)\x02Eroare la ieșirea d" +
	"in WireGuard\x02Nu se poate ieși din serviciu din cauza: %[1]v. Poți opr" +
	"i WireGuard din managerul de servicii.\x02Este disponibilă o actualizare" +
	" pentru WireGuard. Se recomandă ferm actualizarea imediată.\x02Stare: se" +
	" așteaptă utilizatorul\x02Actualizare acum\x02Stare: se așteaptă servici" +
	"ul de actualizare\x02Eroare: %[1]v. Încearcă din nou.\x02Stare: finaliza" +
	"tă!\x02http2: Framer %[1]p: decodificarea cadrului recent scris a eșuat" +
	"\x02http2: Framer %[1]p: a scris %[2]v\x02http2: Framer %[1]p: a citit %" +
	"[2]v\x02http2: câmp hpack decodificat %+[1]v"

var ruIndex = []uint32{ // 177 elements
	// Entry 0 - 1F
	0x00000000, 0x0000000d, 0x000000a9, 0x000000d4,
	0x00000107, 0x00000166, 0x000001c8, 0x0000021f,
	0x000002a6, 0x0000034a, 0x000003b2, 0x000003bf,
	0x000003fc, 0x00000429, 0x00000456, 0x00000483,
	0x000004c0, 0x000004fd, 0x0000050e, 0x00000517,
	0x00000524, 0x00000531, 0x0000053e, 0x0000054b,
	0x00000558, 0x0000057f, 0x000005bd, 0x000005fc,
	0x0000062a, 0x00000662, 0x0000067f, 0x000006a1,
	// Entry 20 - 3F
	0x000006f7, 0x00000720, 0x00000775, 0x000007b4,
	0x000007d7, 0x00000806, 0x00000839, 0x00000839,
	0x0000086b, 0x000008a5, 0x000008da, 0x00000924,
	0x0000093a, 0x0000097e, 0x000009be, 0x00000a01,
	0x00000a39, 0x00000a70, 0x00000a73, 0x00000a76,
	0x00000a83, 0x00000a9c, 0x00000b5a, 0x00000b69,
	0x00000b88, 0x00000b96, 0x00000baa, 0x00000bc0,
	0x00000bdd, 0x00000be7, 0x00000bec, 0x00000bfd,
	// Entry 40 - 5F
	0x00000c11, 0x00000c26, 0x00000c4e, 0x00000c6c,
	0x00000c9d, 0x00000cc8, 0x00000cda, 0x00000ceb,
	0x00000d1e, 0x00000d69, 0x00000da1, 0x00000dd7,
	0x00000df1, 0x00000df8, 0x00000e16, 0x00000e40,
	0x00000e49, 0x00000e67, 0x00000e7e, 0x00000ebc,
	0x0000109a, 0x000010ae, 0x000010bb, 0x000010d6,
	0x000010f6, 0x00001111, 0x0000114b, 0x00001183,
	0x000011ae, 0x000011f6, 0x0000123d, 0x00001262,
	// Entry 60 - 7F
	0x000012c4, 0x000012d7, 0x000012ee, 0x000012ff,
	0x00001314, 0x0000133e, 0x0000134b, 0x00001361,
	0x00001378, 0x0000139b, 0x000013a6, 0x000013c8,
	0x00001410, 0x0000143a, 0x0000144b, 0x00001467,
	0x000014e2, 0x000014f9, 0x00001527, 0x0000157b,
	0x000015a1, 0x000015c4, 0x000015d9, 0x00001605,
	0x00001637, 0x00001643, 0x00001669, 0x0000167a,
	0x0000168e, 0x000016a2, 0x000016bb, 0x000016e4,
	// Entry 80 - 9F
	0x000016ff, 0x00001726, 0x0000174d, 0x0000177d,
	0x00001808, 0x00001817, 0x00001833, 0x00001864,
	0x00001884, 0x000018b5, 0x000018f0, 0x00001908,
	0x00001947, 0x00001988, 0x000019ba, 0x00001a0a,
	0x00001a64, 0x00001aab, 0x00001afb, 0x00001b29,
	0x00001bfd, 0x00001cf9, 0x00001d2b, 0x00001dcb,
	0x00001f13, 0x00001f3d, 0x00001f8d, 0x00001fd8,
	0x0000200a, 0x00002044, 0x00002076, 0x0000216d,
	// Entry A0 - BF
	0x000021ca, 0x000021f8, 0x00002230, 0x00002262,
	0x000022af, 0x000022d8, 0x00002372, 0x000023fa,
	0x00002432, 0x00002450, 0x00002473, 0x000024ac,
	0x000024ce, 0x00002542, 0x0000256c, 0x0000259a,
	0x000025ce,
} // Size: 732 bytes

const ruData string = "" + // Size: 9678 bytes
	"\x02Ошибка\x02(нет аргумента): получить права администратора и установит" +
	"ь административную службу\x02Использование: %[1]s [\x0a%[2]s]\x02Параме" +
	"тры командной строки\x02Ошибка определения или процесс работает как WOW" +
	"64: %[1]v\x02Используйте 64-битную версию WireGuard на этом компьютере." +
	"\x02Не удается открыть токен текущего процесса: %[1]v\x02WireGuard может" +
	" использоваться только пользователями, входящими в группу %[1]s.\x02Wire" +
	"Guard запущен, но пользовательский интерфейс доступен только с рабочих с" +
	"толов группы %[1]s.\x02Значок в системном трее WireGuard не появился по" +
	"сле 30 секунд.\x02Сейчас\x02Системные часы переведены назад!\x14\x01" +
	"\x81\x01\x00\x04\x08\x02%[1]dг\x05\x08\x02%[1]dг\x02\x08\x02%[1]dг\x00" +
	"\x08\x02%[1]dг\x14\x01\x81\x01\x00\x04\x08\x02%[1]dд\x05\x08\x02%[1]dд" +
	"\x02\x08\x02%[1]dд\x00\x08\x02%[1]dд\x14\x01\x81\x01\x00\x04\x08\x02%[1]" +
	"dч\x05\x08\x02%[1]dч\x02\x08\x02%[1]dч\x00\x08\x02%[1]dч\x14\x01\x81\x01" +
	"\x00\x04\x0c\x02%[1]dмин\x05\x0c\x02%[1]dмин\x02\x0c\x02%[1]dмин\x00\x0c" +
	"\x02%[1]dмин\x14\x01\x81\x01\x00\x04\x0c\x02%[1]dсек\x05\x0c\x02%[1]dсек" +
	"\x02\x0c\x02%[1]dсек\x00\x0c\x02%[1]dсек\x02%[1]s назад\x02%[1]d Б\x02%." +
	"2[1]f Кб\x02%.2[1]f Мб\x02%.2[1]f Гб\x02%.2[1]f Тб\x02%[1]s: %[2]q\x02Не" +
	"допустимый IP-адрес\x02Недопустимая длина префикса сети\x02Отсутствует " +
	"порт IP-адреса сервера\x02Неверный IP-адрес сервера\x02В скобках должен" +
	" быть IPv6 адрес\x02Недопустимый MTU\x02Недопустимый порт\x02Недопустимо" +
	"е значение поддержания соединения\x02Недопустимый ключ: %[1]v\x02Ключи " +
	"должны декодироваться ровно с 32 байтами\x02Число должно быть между 0 и" +
	" 2^64-1: %[1]v\x02Две запятые подряд\x02Неправильное имя туннеля\x02Стро" +
	"ка должна быть в секции\x02Ключ должен иметь значение\x02Неверный ключ " +
	"для секции [Interface]\x02Неверный ключ для секции [Peer]\x02В Интерфей" +
	"се должен быть приватный ключ\x02[не указано]\x02Все пиры должны иметь " +
	"открытые ключи\x02Ошибка при получении конфигурации\x02Неверный ключ дл" +
	"я секции Интерфейса\x02Версия протокола должна быть 1\x02Неверный ключ " +
	"для секции Пира\x02, \x02, \x02О WireGuard\x02Логотип WireGuard\x02Верс" +
	"ия приложения: %[1]s\x0aВерсия бэкэнда: %[2]s\x0aВерсия перехода: %[3]s" +
	"\x0aОперационная система: %[4]s\x0aАрхитектура: %[5]s\x02Закрыть\x02♥ &П" +
	"ожертвовать!\x02Статус:\x02&Отключить\x02&Подключить\x02Публичный ключ:" +
	"\x02Порт:\x02MTU:\x02IP-адреса:\x02DNS-серверы:\x02Общий ключ:\x02Разреш" +
	"енные IP-адреса:\x02IP-адрес сервера:\x02Поддерживание соединения:\x02П" +
	"оследнее рукопожатие:\x02Передача:\x02включено\x02Получено %[1]s, отпра" +
	"влено %[2]s\x02Не удалось определить состояние туннеля\x02Не удалось по" +
	"дключить туннель\x02Не удалось отключить туннель\x02Интерфейс: %[1]s" +
	"\x02Пир\x02Создать туннель\x02Редактировать туннель\x02&Имя:\x02&Публичн" +
	"ый ключ:\x02(неизвестно)\x02&Блокировать нетуннельный трафик\x02Когда к" +
	"онфигурация имеет ровно одного пира, и у этого пира есть разрешенные IP" +
	", содержащие хотя бы один из 0.0.0.0/0 или ::/0, то служба туннеля обязы" +
	"вает брандмауэр блокировать весь входящий и исходящий трафик, который н" +
	"е проходит через туннель, за исключением DHCP и NDP.\x02&Сохранить\x02О" +
	"тмена\x02&Конфигурация:\x02Недопустимое имя\x02Требуется имя.\x02Имя ту" +
	"ннеля ‘%[1]s’ недопустимо.\x02Не удалось отобразить туннели\x02Туннель " +
	"уже существует\x02Туннель с именем ’%[1]s’ уже существует.\x02Не удалос" +
	"ь создать новую конфигурацию\x02Ошибка записи файла\x02Файл '%[1]s' уже" +
	" существует!\x0a\x0aВы хотите перезаписать его?\x02Подключен\x02Подключе" +
	"ние\x02Отключен\x02Отключение\x02Неизвестное состояние\x02Журнал\x02&Ко" +
	"пировать\x02Выбрать &всё\x02&Сохранить в файл…\x02Время\x02Сообщение Жу" +
	"рнала\x02Текстовые файлы (*.txt)|*.txt|Все файлы (*.*)|*.*\x02Экспорт Ж" +
	"урнала в файл\x02&О WireGuard…\x02Ошибка туннеля\x02%[1]s\x0a\x0aОбрати" +
	"тесь к журналу для получения дополнительной информации.\x02%[1]s (устар" +
	"ел)\x02Ошибка обнаружения WireGuard\x02Не удалось дождаться появления о" +
	"кна WireGuard: %[1]v\x02WireGuard: Деактивирован\x02Статус: Неизвестен" +
	"\x02Адреса: нет\x02&Управление туннелями…\x02&Импорт туннелей из файла…" +
	"\x02Вы&ход\x02Ошибка туннеля WireGuard\x02WireGuard: %[1]s\x02Статус: %[" +
	"1]s\x02Адреса: %[1]s\x02WireGuard Включен\x02Туннель %[1]s подключен." +
	"\x02WireGuard Выключен\x02Туннель %[1]s отключен.\x02Доступно обновление" +
	"!\x02Доступно обновление WireGuard\x02Доступно обновление для WireGuard." +
	" Рекомендуется обновить его как можно скорее.\x02Туннели\x02&Редактирова" +
	"ть\x02Добавить &пустой туннель…\x02Добавить туннель\x02Удалить выбранны" +
	"е туннели\x02Экспорт всех туннелей в zip-архив\x02&Переключить\x02Экспо" +
	"рт всех туннелей в &zip-архив…\x02Редактировать &выбранный туннель…\x02" +
	"&Удалить выбранные туннели\x02Невозможно импортировать конфигурацию: %[1" +
	"]v\x02Не удалось перечислить существующие туннели: %[1]v\x02Туннель с им" +
	"енем ’%[1]s’ уже существует\x02Невозможно импортировать конфигурацию: %" +
	"[1]v\x02Импортированные туннели\x14\x01\x81\x01\x00\x041\x02Импортирован" +
	"ы туннели: %[1]d\x051\x02Импортированы туннели: %[1]d\x024\x02Импортиро" +
	"ванный %[1]d туннель\x001\x02Импортированы туннели: %[1]d\x14\x02\x80" +
	"\x01\x04<\x02Импортированы туннели: %[1]d из %[2]d\x05<\x02Импортированы" +
	" туннели: %[1]d из %[2]d\x02<\x02Импортированы туннели: %[1]d из %[2]d" +
	"\x00<\x02Импортированы туннели: %[1]d из %[2]d\x02Не удалось создать тун" +
	"нель\x14\x01\x81\x01\x00\x04%\x02Удалить туннели: %[1]d\x05%\x02Удалить" +
	" туннели: %[1]d\x02$\x02Удалить %[1]d туннель\x00%\x02Удалить туннели: %" +
	"[1]d\x14\x01\x81\x01\x00\x04O\x02Вы уверены, что хотите удалить туннели:" +
	" %[1]d?\x05O\x02Вы уверены, что хотите удалить туннели: %[1]d?\x02N\x02В" +
	"ы уверены, что хотите удалить %[1]d туннель?\x00O\x02Вы уверены, что хо" +
	"тите удалить туннели: %[1]d?\x02Удалить туннель ‘%[1]s’\x02Вы уверены, " +
	"что хотите удалить '%[1]s' туннель?\x02%[1]s Данное действие невозможно" +
	" отменить.\x02Не удалось удалить туннель\x02Невозможно удалить туннель: " +
	"%[1]s\x02Не удалось удалить туннели\x14\x01\x81\x01\x00\x04;\x02туннелей" +
	" не удалось удалить: %[1]d\x05;\x02туннелей не удалось удалить: %[1]d" +
	"\x029\x02%[1]d туннель не удалось удалить.\x00;\x02туннелей не удалось у" +
	"далить: %[1]d\x02Файлы конфигурации (*.zip, *.conf)|*.zip;*.conf|Все фа" +
	"йлы (*.*)|*.*\x02Импорт туннелей из файла\x02Конфигурация ZIP файлов (*" +
	".zip)|*.zip\x02Экспорт туннелей в zip-архив\x02%[1]s (неподписанная сбор" +
	"ка, нет обновлений)\x02Ошибка выхода из WireGuard\x02Не удается выйти и" +
	"з сервиса из-за: %[1]v. Вы можете остановить WireGuard из менеджера слу" +
	"жб.\x02Доступно обновление WireGuard. Настоятельно рекомендуем обновить" +
	" приложение.\x02Статус: Ожидание пользователя\x02Обновить Сейчас\x02Стат" +
	"ус: Обновление\x02Ошибка: %[1]v. Попробуйте еще раз.\x02Статус: Заверше" +
	"но!\x02http2: Framer %[1]p: не удалось декодировать только что записанн" +
	"ый кадр\x02http2: Framer %[1]p: написал %[2]v\x02http2: Framer %[1]p: п" +
	"рочитать %[2]v\x02http2: декодирован hpack поле %+[1]v"

var skIndex = []uint32{ // 177 elements
	// Entry 0 - 1F
	0x00000000, 0x00000006, 0x0000005e, 0x00000078,
	0x00000097, 0x000000d1, 0x00000124, 0x0000015c,
	0x0000019e, 0x00000208, 0x00000252, 0x00000258,
	0x00000280, 0x00000280, 0x000002b8, 0x000002f9,
	0x0000033c, 0x00000381, 0x0000038c, 0x00000395,
	0x000003a2, 0x000003af, 0x000003bc, 0x000003c9,
	0x000003d6, 0x000003ea, 0x00000410, 0x00000435,
	0x00000459, 0x00000482, 0x00000490, 0x0000049f,
	// Entry 20 - 3F
	0x000004c1, 0x000004da, 0x0000050f, 0x00000542,
	0x00000558, 0x00000575, 0x00000594, 0x000005d6,
	0x000005f7, 0x0000061c, 0x0000063c, 0x0000066f,
	0x00000683, 0x000006b8, 0x000006dc, 0x000006ff,
	0x0000071d, 0x0000073b, 0x0000073e, 0x00000740,
	0x0000074c, 0x00000764, 0x000007d7, 0x000007e1,
	0x000007f0, 0x000007f6, 0x00000805, 0x00000812,
	0x00000824, 0x00000824, 0x00000824, 0x00000824,
	// Entry 40 - 5F
	0x00000824, 0x00000824, 0x00000824, 0x00000824,
	0x00000824, 0x00000824, 0x00000824, 0x00000824,
	0x00000824, 0x00000824, 0x00000824, 0x00000824,
	0x00000824, 0x00000824, 0x00000824, 0x00000824,
	0x00000824, 0x00000824, 0x00000824, 0x00000824,
	0x00000824, 0x00000824, 0x00000824, 0x00000824,
	0x00000824, 0x00000824, 0x00000824, 0x00000824,
	0x00000824, 0x00000824, 0x00000824, 0x00000824,
	// Entry 60 - 7F
	0x00000824, 0x00000824, 0x00000824, 0x00000824,
	0x00000824, 0x00000824, 0x00000824, 0x00000824,
	0x00000824, 0x00000824, 0x00000824, 0x00000824,
	0x00000824, 0x00000824, 0x00000824, 0x00000824,
	0x00000824, 0x00000824, 0x00000824, 0x00000824,
	0x00000824, 0x00000824, 0x00000824, 0x00000824,
	0x00000824, 0x00000824, 0x00000824, 0x00000824,
	0x00000824, 0x00000824, 0x00000824, 0x00000824,
	// Entry 80 - 9F
	0x00000824, 0x00000824, 0x00000824, 0x00000824,
	0x00000824, 0x00000824, 0x00000824, 0x00000824,
	0x00000824, 0x00000824, 0x00000824, 0x00000824,
	0x00000824, 0x00000824, 0x00000824, 0x00000824,
	0x00000824, 0x00000824, 0x00000824, 0x00000824,
	0x00000824, 0x00000824, 0x00000824, 0x00000824,
	0x00000824, 0x00000824, 0x00000824, 0x00000824,
	0x00000824, 0x00000824, 0x00000824, 0x00000824,
	// Entry A0 - BF
	0x00000824, 0x00000824, 0x00000824, 0x00000824,
	0x00000824, 0x00000824, 0x00000824, 0x00000824,
	0x00000824, 0x00000824, 0x00000824, 0x00000824,
	0x00000824, 0x00000824, 0x00000824, 0x00000824,
	0x00000824,
} // Size: 732 bytes

const skData string = "" + // Size: 2084 bytes
	"\x02Chyba\x02(bez argumentu): získať administrátorské práva a nainštalov" +
	"ať službu manažéra\x02Použitie: %[1]s [\x0a%[2]s]\x02Možnosti príkazovéh" +
	"o riadku\x02Nepodarilo sa zistiť, či proces beží pod WOW64: %[1]v\x02Na " +
	"tomto počítači je potrebné použiť 64 bitovú verziu aplikácie WireGuard." +
	"\x02Nepodarilo sa otvoriť token aktuálneho procesu: %[1]v\x02WireGuard m" +
	"ôžu používať iba členovia Builtin skupiny %[1]s.\x02WireGuard je spuste" +
	"ný, ale používateľské rozhranie je prístupné iba členom Builtin skupiny " +
	"%[1]s.\x02WireGuard ikona sa ani po 30 sekundách neobjavila na systémove" +
	"j lište.\x02Teraz\x02Systémové hodiny sa vrátili v čase!\x14\x01\x81\x01" +
	"\x00\x04\x0a\x02%[1]d dni\x05\x0b\x02%[1]d dní\x02\x0b\x02%[1]d deň\x00" +
	"\x0b\x02%[1]d dní\x14\x01\x81\x01\x00\x04\x0d\x02%[1]d hodiny\x05\x0d" +
	"\x02%[1]d hodín\x02\x0d\x02%[1]d hodina\x00\x0d\x02%[1]d hodín\x14\x01" +
	"\x81\x01\x00\x04\x0e\x02%[1]d minúty\x05\x0d\x02%[1]d minút\x02\x0e\x02%" +
	"[1]d minúta\x00\x0d\x02%[1]d minút\x14\x01\x81\x01\x00\x04\x0e\x02%[1]d " +
	"sekundy\x05\x0e\x02%[1]d sekúnd\x02\x0e\x02%[1]d sekunda\x00\x0e\x02%[1]" +
	"d sekúnd\x02Pred %[1]s\x02%[1]d\u00a0B\x02%.2[1]f\u00a0KiB\x02%.2[1]f" +
	"\u00a0MiB\x02%.2[1]f\u00a0GiB\x02%.2[1]f\u00a0TiB\x02%[1]s: %[2]q\x02Nep" +
	"latná adresa IP\x02Neplatná dĺžka sieťového prefixu\x02Koncovému bodu ch" +
	"ýba číslo portu\x02Neplatný hostiteľ koncového bodu\x02Medzi zátvorkami" +
	" musí byť IPv6 adresa\x02Neplatné MTU\x02Neplatný port\x02Neplatný perzi" +
	"stentný keepalive\x02Neplatný kľúč: %[1]v\x02Dekódované kľúče musia mať " +
	"veľkosť 32 bajtov\x02Číslo musí mať hodnotu medzi 0 a 2^64-1: %[1]v\x02D" +
	"ve čiarky v poradí\x02Názov tunela nie je platný\x02Sekcia musí obsahova" +
	"ť čiaru\x02Konfiguračný kľúč neobsahuje separátor (znamienko rovnosti)" +
	"\x02Kľúč musí obsahovať hodnotu\x02Neplatný kľúč sekcie [Interface]\x02N" +
	"eplatný kľúč sekcie [Peer]\x02Rozhranie musí mať priradený súkromný kľúč" +
	"\x02[nešpecifikované]\x02Všetci peeri musia mať priradený verejný kľúč" +
	"\x02Chyba pri získavaní konfigurácie\x02Neplatný kľúč sekcie rozhrania" +
	"\x02Verzia protokolu musí byť 1\x02Neplatný kľúč peer sekcie\x02, \x02 " +
	"\x02O WireGuard\x02Obrázok WireGuard loga\x02Verzia aplikácie: %[1]s\x0a" +
	"Verzia Go backendu: %[2]s\x0aVerzia Go: %[3]s\x0aOperačný systém: %[4]s" +
	"\x0aArchitektúra: %[5]s\x02Zatvoriť\x02♥ a Darovat!\x02Stav:\x02a Deakti" +
	"vovať\x02a Aktivovať\x02Verejný kľúč:"

var slIndex = []uint32{ // 177 elements
	// Entry 0 - 1F
	0x00000000, 0x00000007, 0x00000058, 0x00000070,
	0x00000089, 0x000000c1, 0x00000107, 0x0000013e,
	0x00000190, 0x000001f6, 0x0000023a, 0x0000023f,
	0x0000025e, 0x00000296, 0x000002cd, 0x00000301,
	0x00000341, 0x00000385, 0x00000391, 0x0000039a,
	0x000003a7, 0x000003b4, 0x000003c1, 0x000003ce,
	0x000003db, 0x000003ee, 0x00000412, 0x00000434,
	0x0000045d, 0x00000483, 0x00000490, 0x0000049f,
	// Entry 20 - 3F
	0x000004c3, 0x000004da, 0x0000050b, 0x0000053f,
	0x00000554, 0x0000056b, 0x00000586, 0x00000586,
	0x000005a1, 0x000005c6, 0x000005e6, 0x00000608,
	0x00000616, 0x0000063d, 0x0000065d, 0x0000067f,
	0x0000069d, 0x000006bf, 0x000006c2, 0x000006c4,
	0x000006d1, 0x000006ef, 0x00000764, 0x0000076a,
	0x00000778, 0x00000780, 0x0000078d, 0x00000798,
	0x000007a6, 0x000007b9, 0x000007be, 0x000007c7,
	// Entry 40 - 5F
	0x000007d7, 0x000007ed, 0x000007fe, 0x0000080e,
	0x0000082a, 0x0000083c, 0x00000844, 0x0000084f,
	0x0000086c, 0x00000890, 0x000008ae, 0x000008ce,
	0x000008dd, 0x000008e5, 0x000008f7, 0x00000903,
	0x00000909, 0x00000918, 0x00000922, 0x0000094c,
	0x00000a6d, 0x00000a75, 0x00000a7f, 0x00000a8f,
	0x00000a9c, 0x00000aac, 0x00000ace, 0x00000afe,
	0x00000b10, 0x00000b3b, 0x00000b62, 0x00000b80,
	// Entry 60 - 7F
	0x00000bbb, 0x00000bc3, 0x00000bcf, 0x00000bd9,
	0x00000be7, 0x00000bf6, 0x00000bfe, 0x00000c07,
	0x00000c13, 0x00000c2b, 0x00000c30, 0x00000c46,
	0x00000c7e, 0x00000c98, 0x00000cab, 0x00000cb9,
	0x00000ce8, 0x00000cfe, 0x00000d1b, 0x00000d56,
	0x00000d6d, 0x00000d7c, 0x00000d8a, 0x00000da1,
	0x00000dc0, 0x00000dc7, 0x00000ddf, 0x00000df0,
	0x00000dfe, 0x00000e0d, 0x00000e21, 0x00000e3f,
	// Entry 80 - 9F
	0x00000e55, 0x00000e75, 0x00000e8e, 0x00000eb1,
	0x00000ef6, 0x00000efd, 0x00000f04, 0x00000f1d,
	0x00000f29, 0x00000f41, 0x00000f59, 0x00000f63,
	0x00000f81, 0x00000f9a, 0x00000fb3, 0x00000fe1,
	0x00001014, 0x00001039, 0x0000105f, 0x0000106f,
	0x000010d3, 0x0000115e, 0x0000117f, 0x000011e4,
	0x000012d1, 0x000012ec, 0x00001327, 0x00001352,
	0x0000136c, 0x00001394, 0x000013af, 0x00001463,
	// Entry A0 - BF
	0x000014b0, 0x000014c9, 0x000014f4, 0x00001511,
	0x00001542, 0x00001562, 0x000015cf, 0x00001622,
	0x0000163e, 0x0000164c, 0x00001673, 0x00001695,
	0x000016a7, 0x000016ef, 0x00001713, 0x00001737,
	0x0000175c,
} // Size: 732 bytes

const slData string = "" + // Size: 5980 bytes
	"\x02Napaka\x02(brez argumenta): povzdigni na skrbniške pravice in namest" +
	"i skrbniško storitev\x02Uporaba: %[1]s [\x0a%[2]s]\x02Možnosti ukazne vr" +
	"stice\x02Napaka pri določanju ali proces teče kot WOW64: %[1]v\x02Na tem" +
	"u računalniku morate uporabiti 64-bitno različico WireGuarda.\x02Napaka " +
	"pri odpiranju žetona trenutnega procesa: %[1]v\x02WireGuard lahko uporab" +
	"ljajo samo uporabniki, ki so člani vgrajene skupine %[1]s.\x02WireGuard " +
	"je zagnan, vendar je up. vmesnik dostopen samo z namizij uporabnikov čla" +
	"nov skupine %[1]s.\x02Ikona WireGuarda se po 30 sekundah ni pojavila v s" +
	"istemski vrstici.\x02Zdaj\x02Sistemska ura prevrtena nazaj!\x14\x01\x81" +
	"\x01\x00\x04\x0b\x02%[1]d leta\x02\x0b\x02%[1]d leto\x03\x0b\x02%[1]d le" +
	"ti\x00\x0a\x02%[1]d let\x14\x01\x81\x01\x00\x04\x0a\x02%[1]d dni\x02\x0a" +
	"\x02%[1]d dan\x03\x0c\x02%[1]d dneva\x00\x0a\x02%[1]d dni\x14\x01\x81" +
	"\x01\x00\x04\x0a\x02%[1]d ure\x02\x0a\x02%[1]d uro\x03\x0a\x02%[1]d uri" +
	"\x00\x09\x02%[1]d ur\x14\x01\x81\x01\x00\x04\x0d\x02%[1]d minute\x02\x0d" +
	"\x02%[1]d minuto\x03\x0d\x02%[1]d minuti\x00\x0c\x02%[1]d minut\x14\x01" +
	"\x81\x01\x00\x04\x0e\x02%[1]d sekunde\x02\x0e\x02%[1]d sekundo\x03\x0e" +
	"\x02%[1]d sekundi\x00\x0d\x02%[1]d sekund\x02%[1]s nazaj\x02%[1]d\u00a0B" +
	"\x02%.2[1]f\u00a0KiB\x02%.2[1]f\u00a0MiB\x02%.2[1]f\u00a0GiB\x02%.2[1]f" +
	"\u00a0TiB\x02%[1]s: %[2]q\x02Napačen naslov IP\x02Napačna dolžina predpo" +
	"ne omrežja\x02Pri končni točki manjkajo vrata\x02Pri končni točki je gos" +
	"titelj napačen\x02Oklepaji morajo vsebovati naslov IPv6\x02Napačen MTU" +
	"\x02Napačna vrata\x02Napačno trajno ohranjanje povezave\x02Napačen ključ" +
	": %[1]v\x02Dekodirani ključi morajo biti natanko 32 bajtov\x02Številka m" +
	"ora biti število med 0 in 2^64-1: %[1]v\x02Dve zaporedni vejici\x02Ime t" +
	"unela ni veljavno\x02Vrstica mora biti v odseku\x02Ključ mora imeti vred" +
	"nost\x02Napačen ključ za odsek [Interface]\x02Napačen ključ za odsek [Pe" +
	"er]\x02Vmesnik mora imeti zasebni ključ\x02[ni navedeno]\x02Vsi vrstniki" +
	" morajo imeti javni ključ\x02Napaka pri branju konfiguracije\x02Napačen " +
	"ključ za odsek vmesnika\x02Verzija protokola mora biti 1\x02Napačen klju" +
	"č za odsek vrstnika\x02, \x02 \x02O WireGuardu\x02Slika WireGuardovega " +
	"logotipa\x02Verzija aplikacije: %[1]s\x0aVerzija wireguard-go: %[2]s\x0a" +
	"Verzija Go: %[3]s\x0aOperacijski sistem: %[4]s\x0aArhitektura: %[5]s\x02" +
	"Zapri\x02♥ &Doniraj!\x02Status:\x02&Deaktiviraj\x02&Aktiviraj\x02Javni k" +
	"ljuč:\x02Vrata poslušanja:\x02MTU:\x02Naslovi:\x02Strežniki DNS:\x02Klju" +
	"č v skupni rabi:\x02Dovoljeni IP-ji:\x02Končna točka:\x02Trajno ohranja" +
	"nje povezave:\x02Zadnje rokovanje:\x02Prenos:\x02omogočeno\x02%[1]s prej" +
	"eto, %[2]s poslano\x02Napaka pri določanju stanja tunela\x02Napaka pri a" +
	"ktiviranju tunela\x02Napaka pri deaktiviranju tunela\x02Vmesnik: %[1]s" +
	"\x02Vrstnik\x02Ustvari nov tunel\x02Uredi tunel\x02&Ime:\x02&Javni ključ" +
	":\x02(neznano)\x02&Blokiraj promet izven tunela (varovalka)\x02Kadar ima" +
	" konfiguracija natanko enega vrstnika in njegov spisek dovoljenih IP-jev" +
	" vsebuje vsaj enega izmed 0.0.0.0/0 ali ::/0, bo storitev tunela vzposta" +
	"vila pravila požarnega zidu, ki bodo blokirala ves promet, ki ni niti za" +
	" niti iz vmesnika tunela s posebnimi izjemami za DHCP and NDP.\x02&Shran" +
	"i\x02Prekliči\x02&Konfiguracija:\x02Napačno ime\x02Ime je obvezno.\x02Im" +
	"e tunela »%[1]s« ni veljavno.\x02Napaka pri pripravi seznama obstoječih " +
	"tunelov\x02Tunel že obstaja\x02Drug tunel z imenom »%[1]s« že obstaja." +
	"\x02Napaka pri izdelavi nove konfiguracije\x02Napaka pri pisanju v datot" +
	"eko\x02Datoteka »%[1]s« že obstaja.\x0a\x0aAli jo želite prepisati?\x02A" +
	"ktivno\x02Se aktivira\x02Neaktivno\x02Se deaktivira\x02Neznano stanje" +
	"\x02Dnevnik\x02&Kopiraj\x02&Izberi vse\x02&Shrani v datoteko\u00a0…\x02Č" +
	"as\x02Sporočilo v dnevniku\x02Tekstovne datoteke (*.txt)|*.txt|Vse datot" +
	"eke (*.*)|*.*\x02Izvozi dnevnik v datoteko\x02O WireGu&ardu\u00a0…\x02Na" +
	"paka tunela\x02%[1]s\x0a\x0aDodatne informacije najdete v dnevniku.\x02%" +
	"[1]s (neposodobljen)\x02Napaka zaznavanja WireGuarda\x02Čakanje, da se p" +
	"ojavi WireGuardovo okno, ni možno: %[1]v\x02WireGuard: Deaktiviran\x02St" +
	"atus: Neznan\x02Naslovi: Brez\x02&Upravljaj tunele\u00a0…\x02&Uvozi tune" +
	"l(e) iz datoteke…\x02I&zhod\x02Napaka tunela WireGuard\x02WireGuard: %[1" +
	"]s\x02Status: %[1]s\x02Naslovi: %[1]s\x02WireGuard aktiviran\x02Tunel %[" +
	"1]s je bil aktiviran.\x02WireGuard deaktiviran\x02Tunel %[1]s je bil dea" +
	"ktiviran.\x02Na voljo je posodobitev!\x02Posodobitev WireGuarda je na vo" +
	"ljo\x02Posodobitev WireGuarda je na voljo. Svetujemo posodobitev čim pre" +
	"j.\x02Tuneli\x02&Uredi\x02Dodaj &prazen tunel\u00a0…\x02Dodaj tunel\x02O" +
	"dstrani izbrane tunele\x02Izvozi vse tunele v zip\x02&Preklopi\x02Izvozi" +
	" vse tunele v &zip\u00a0…\x02Uredi &izbran tunel\u00a0…\x02Odst&rani izb" +
	"rane tunele\x02Napaka pri uvozu izbrane konfiguracije: %[1]v\x02Napaka p" +
	"ri preštevanju obstoječih tunelov: %[1]v\x02Tunel z imenom »%[1]s« že ob" +
	"staja\x02Napaka pri uvozu konfiguracije: %[1]v\x02Uvoženi tuneli\x14\x01" +
	"\x81\x01\x00\x04\x16\x02Uvoženi %[1]d tuneli\x02\x14\x02Uvožen %[1]d tun" +
	"el\x03\x16\x02Uvožena %[1]d tunela\x00\x17\x02Uvoženo %[1]d tunelov\x14" +
	"\x02\x80\x01\x04 \x02Uvoženi %[1]d od %[2]d tunelov\x02\x1f\x02Uvožen %[" +
	"1]d od %[2]d tunelov\x03 \x02Uvožena %[1]d od %[2]d tunelov\x00 \x02Uvož" +
	"eno %[1]d od %[2]d tunelov\x02Tunela ni bilo mogoče ustvariti\x14\x01" +
	"\x81\x01\x00\x04\x16\x02Izbriši %[1]d tunele\x02\x15\x02Izbriši %[1]d tu" +
	"nel\x03\x16\x02Izbriši %[1]d tunela\x00\x17\x02Izbriši %[1]d tunelov\x14" +
	"\x01\x81\x01\x00\x048\x02Ali ste prepričani, da želite izbrisati %[1]d t" +
	"unele?\x027\x02Ali ste prepričani, da želite izbrisati %[1]d tunel?\x038" +
	"\x02Ali ste prepričani, da želite izbrisati %[1]d tunela?\x009\x02Ali st" +
	"e prepričani, da želite izbrisati %[1]d tunelov?\x02Izbriši tunel ‘%[1]s" +
	"’\x02Ali ste prepričani, da želite izbrisati tunel »%[1]s«?\x02%[1]s T" +
	"ega dejanja ne morete razveljaviti.\x02Napaka pri izbrisu tunela\x02Napa" +
	"ka pri odstranjevanju tunela: %[1]s\x02Napaka pri izbrisu tunelov\x14" +
	"\x01\x81\x01\x00\x04*\x02%[1]d tunelov ni bilo mogoče odstraniti.\x02)" +
	"\x02%[1]d tunela ni bilo mogoče odstraniti.\x03*\x02%[1]d tunelov ni bil" +
	"o mogoče odstraniti.\x00*\x02%[1]d tunelov ni bilo mogoče odstraniti." +
	"\x02Konfiguracijske datoteke (*.zip, *.conf)|*.zip;*.conf|Vse datoteke (" +
	"*.*)|*.*\x02Uvozi tunele iz datoteke\x02Konfiguracijske datoteke ZIP (*." +
	"zip)|*.zip\x02Izvozi tunele v datoteko zip\x02%[1]s (nepodpisane različi" +
	"ce, brez posodobitev)\x02Napaka pri izhodu iz WireGuarda\x02Storitve ni " +
	"bilo mogoče zaustaviti, ker: %[1]v. Poskusite zaustaviti WireGuard z upo" +
	"rabo programa Storitve.\x02Posodobitev WireGuarda je na voljo. Zelo prip" +
	"oročamo posodobitev brez odlašanja.\x02Status: Čaka na uporabnika\x02Pos" +
	"odobi zdaj\x02Status: Čaka na servis za posodobitev\x02Napaka: %[1]v. Po" +
	"skusite ponovno.\x02Status: Končano!\x02http2: Framer %[1]p: napaka pri " +
	"dekodiranju ravnokar zapisanega okvirja\x02http2: Framer %[1]p: zapisano" +
	" %[2]v\x02http2: Framer %[1]p: prebrano %[2]v\x02http2: dekodirano polje" +
	" hpack %+[1]v"

var viIndex = []uint32{ // 177 elements
	// Entry 0 - 1F
	0x00000000, 0x00000006, 0x00000006, 0x00000006,
	0x00000006, 0x00000006, 0x00000006, 0x00000006,
	0x00000006, 0x00000006, 0x00000006, 0x00000011,
	0x00000011, 0x00000023, 0x00000036, 0x00000049,
	0x0000005c, 0x0000006f, 0x0000007e, 0x0000007e,
	0x0000007e, 0x0000007e, 0x0000007e, 0x0000007e,
	0x0000007e, 0x000000a0, 0x000000a0, 0x000000a0,
	0x000000a0, 0x000000a0, 0x000000a0, 0x000000c0,
	// Entry 20 - 3F
	0x000000c0, 0x000000c0, 0x000000c0, 0x000000c0,
	0x000000c0, 0x000000db, 0x000000db, 0x000000db,
	0x000000db, 0x000000db, 0x000000db, 0x000000db,
	0x000000db, 0x000000db, 0x000000db, 0x000000db,
	0x000000db, 0x000000db, 0x000000db, 0x000000db,
	0x000000f5, 0x00000104, 0x0000019b, 0x000001a2,
	0x000001a2, 0x000001b1, 0x000001b1, 0x000001b1,
	0x000001b1, 0x000001b1, 0x000001b1, 0x000001b1,
	// Entry 40 - 5F
	0x000001b1, 0x000001b1, 0x000001b1, 0x000001c0,
	0x000001c0, 0x000001c0, 0x000001c0, 0x000001d2,
	0x000001ec, 0x00000218, 0x00000236, 0x00000257,
	0x00000257, 0x0000026a, 0x00000274, 0x00000286,
	0x00000286, 0x00000286, 0x00000286, 0x00000286,
	0x00000286, 0x00000286, 0x0000028c, 0x0000028c,
	0x000002a3, 0x000002bb, 0x000002e1, 0x00000302,
	0x00000317, 0x00000344, 0x00000344, 0x00000344,
	// Entry 60 - 7F
	0x00000344, 0x00000344, 0x00000344, 0x00000344,
	0x00000344, 0x00000344, 0x00000344, 0x00000344,
	0x00000344, 0x00000344, 0x00000344, 0x00000344,
	0x00000344, 0x00000344, 0x00000344, 0x00000344,
	0x00000344, 0x00000344, 0x00000344, 0x00000344,
	0x00000344, 0x00000344, 0x00000344, 0x00000344,
	0x00000344, 0x00000344, 0x00000344, 0x00000344,
	0x00000344, 0x00000344, 0x00000344, 0x00000344,
	// Entry 80 - 9F
	0x00000344, 0x00000344, 0x00000344, 0x00000344,
	0x00000344, 0x00000344, 0x00000344, 0x00000344,
	0x00000344, 0x00000344, 0x00000344, 0x00000344,
	0x00000344, 0x00000344, 0x00000344, 0x00000344,
	0x00000344, 0x00000344, 0x00000344, 0x00000344,
	0x00000344, 0x00000344, 0x00000344, 0x00000344,
	0x00000344, 0x00000344, 0x00000344, 0x00000344,
	0x00000344, 0x00000344, 0x00000344, 0x00000344,
	// Entry A0 - BF
	0x00000344, 0x00000344, 0x00000344, 0x00000344,
	0x00000344, 0x00000344, 0x00000344, 0x00000344,
	0x00000344, 0x00000344, 0x00000344, 0x00000344,
	0x00000344, 0x00000344, 0x00000344, 0x00000344,
	0x00000344,
} // Size: 732 bytes

const viData string = "" + // Size: 836 bytes
	"\x02Lỗi\x02Vừa xong\x14\x01\x81\x01\x00\x00\x0b\x02%[1]d năm\x14\x01\x81" +
	"\x01\x00\x00\x0c\x02%[1]d ngày\x14\x01\x81\x01\x00\x00\x0c\x02%[1]d giờ" +
	"\x14\x01\x81\x01\x00\x00\x0c\x02%[1]d phút\x14\x01\x81\x01\x00\x00\x0c" +
	"\x02%[1]d giây\x02%[1]s trước\x02Địa chỉ IP không hợp lệ\x02Cổng (port) " +
	"không hợp lệ\x02Tên VPN không hợp lệ\x02Thông tin về WireGuard\x02Logo W" +
	"ireGuard\x02Phiên bản ứng dụng: %[1]s\x0aPhiên bản Golang của WG: %[2]s" +
	"\x0aPhiên bản Golang: %[3]s\x0aHệ điều hành: %[4]s\x0aKiến trúc xử lý: %" +
	"[5]s\x02Đóng\x02Trạng thái:\x02Đầu cuối:\x02đã kích hoạt\x02Nhận %[1]s, " +
	"gứi %[2]s\x02Không thể xác định tình trạng VPN\x02Không thể kích hoạt VP" +
	"N\x02Không thể vô hiệu hóa VPN\x02Mạng ngang hàng\x02Tạo VPN\x02Chỉnh sử" +
	"a VPN\x02Huỷ\x02Tên không hợp lệ\x02Yêu cầu nhập tên.\x02Tên VPN ‘%[1]s'" +
	" không hợp lệ.\x02Không thể liệt kê các VPN\x02VPN đã tồn tại\x02Đã tồn " +
	"tại VPN với tên ‘%[1]s’."

var zh_CNIndex = []uint32{ // 177 elements
	// Entry 0 - 1F
	0x00000000, 0x00000007, 0x00000030, 0x00000047,
	0x00000057, 0x0000008b, 0x000000c8, 0x000000ee,
	0x00000133, 0x0000018d, 0x000001c4, 0x000001cb,
	0x000001e4, 0x000001f5, 0x00000206, 0x0000021a,
	0x0000022e, 0x0000023f, 0x00000249, 0x00000251,
	0x0000025e, 0x0000026b, 0x00000278, 0x00000285,
	0x00000292, 0x000002a1, 0x000002ba, 0x000002dc,
	0x00000303, 0x0000032b, 0x00000336, 0x00000343,
	// Entry 20 - 3F
	0x0000035c, 0x00000374, 0x0000039e, 0x000003cc,
	0x000003e5, 0x000003f8, 0x00000414, 0x00000439,
	0x0000044c, 0x0000046b, 0x00000485, 0x000004a1,
	0x000004ad, 0x000004cf, 0x000004e5, 0x000004fe,
	0x00000516, 0x0000052f, 0x00000533, 0x00000535,
	0x00000546, 0x0000055c, 0x000005c4, 0x000005cb,
	0x000005dc, 0x000005e4, 0x000005f0, 0x000005fc,
	0x00000604, 0x00000612, 0x00000617, 0x0000061f,
	// Entry 40 - 5F
	0x0000062e, 0x0000063f, 0x0000064d, 0x00000655,
	0x00000669, 0x0000067d, 0x00000685, 0x0000068f,
	0x000006aa, 0x000006c3, 0x000006d6, 0x000006ef,
	0x000006fd, 0x00000704, 0x00000714, 0x00000721,
	0x0000072e, 0x0000073b, 0x00000744, 0x00000773,
	0x0000081d, 0x00000829, 0x00000830, 0x0000083d,
	0x0000084a, 0x00000860, 0x0000087e, 0x00000897,
	0x000008a7, 0x000008c8, 0x000008e1, 0x000008f4,
	// Entry 60 - 7F
	0x0000092f, 0x00000939, 0x00000946, 0x00000950,
	0x0000095d, 0x00000964, 0x0000096b, 0x00000977,
	0x00000983, 0x00000992, 0x00000999, 0x000009a6,
	0x000009d8, 0x000009e5, 0x000009fe, 0x00000a0b,
	0x00000a31, 0x00000a43, 0x00000a5a, 0x00000a85,
	0x00000a9a, 0x00000aa9, 0x00000ab5, 0x00000aca,
	0x00000ae8, 0x00000af4, 0x00000b0b, 0x00000b1c,
	0x00000b2a, 0x00000b38, 0x00000b4c, 0x00000b6a,
	// Entry 80 - 9F
	0x00000b7e, 0x00000ba2, 0x00000bb2, 0x00000bc3,
	0x00000c05, 0x00000c0c, 0x00000c18, 0x00000c30,
	0x00000c3d, 0x00000c50, 0x00000c73, 0x00000c8b,
	0x00000cb6, 0x00000cd1, 0x00000ce9, 0x00000d03,
	0x00000d23, 0x00000d50, 0x00000d6a, 0x00000d77,
	0x00000d98, 0x00000dce, 0x00000de1, 0x00000dff,
	0x00000e32, 0x00000e4a, 0x00000e74, 0x00000e92,
	0x00000ea5, 0x00000ebf, 0x00000ed2, 0x00000ef9,
	// Entry A0 - BF
	0x00000f3a, 0x00000f50, 0x00000f6b, 0x00000f8e,
	0x00000fbb, 0x00000fd6, 0x00001037, 0x0000106f,
	0x00001084, 0x00001091, 0x000010ac, 0x000010c9,
	0x000010db, 0x0000110f, 0x00001137, 0x0000115f,
	0x00001184,
} // Size: 732 bytes

const zh_CNData string = "" + // Size: 4484 bytes
	"\x02错误\x02(无参数): 提升并安装管理服务\x02用法: %[1]s [\x0a%[2]s]\x02命令行选项\x02无法确定该进程是" +
	"否在WOW64下运行: %[1]v\x02您必须在此计算机上使用64位版本的 WireGuard。\x02无法打开当前进程令牌: %[1]v" +
	"\x02WireGuard 可能只能被内建的 %[1]s 小组中的成员使用。\x02WireGuard 正在运行，但用户界面只能从内建的 %[1" +
	"]s 小组的桌面访问。\x02WireGuard 系统托盘图标在30秒后没有出现。\x02刚刚\x02系统时间倒退了！\x14\x01\x81" +
	"\x01\x00\x00\x0a\x02%[1]d 年\x14\x01\x81\x01\x00\x00\x0a\x02%[1]d 天\x14" +
	"\x01\x81\x01\x00\x00\x0d\x02%[1]d 小时\x14\x01\x81\x01\x00\x00\x0d\x02%[1]" +
	"d 分钟\x14\x01\x81\x01\x00\x00\x0a\x02%[1]d 秒\x02%[1]s 前\x02%[1]d B\x02%.2" +
	"[1]f\u00a0KiB\x02%.2[1]f\u00a0MiB\x02%.2[1]f\u00a0GiB\x02%.2[1]f\u00a0Ti" +
	"B\x02%[1]s: %[2]q\x02IP地址无效\x02网络前缀长度无效\x02对端 (endpoint) 中缺少端口\x02对端主机名 " +
	"(endpoint host) 无效\x02方括号中应包含一个 IPv6 地址\x02MTU 无效\x02端口无效\x02连接保活间隔无效" +
	"\x02无效的密钥：%[1]v\x02解码后的密钥长度必须为32字节\x02数值必须介于 0 至 2^64-1 之间: %[1]v\x02一行中" +
	"有两个逗号\x02隧道名称无效\x02行必须出现在段落中\x02配置项必须要有一个等于号\x02必须有一个值\x02[Interface] " +
	"段落的键无效\x02[Peer] 段落的键无效\x02接口必须有一个私钥\x02[未指定]\x02所有节点必须拥有公钥。\x02获取配置时出" +
	"错\x02接口段落的键无效\x02协议版本必须为 1\x02节点段落的键无效\x02、\x02 \x02关于 WireGuard\x02Wi" +
	"reGuard logo 图片\x02应用版本： %[1]s\x0aGo 后端版本： %[2]s\x0aGo 版本： %[3]s\x0a操作系统" +
	"： %[4]s\x0a架构： %[5]s\x02关闭\x02♥ 捐助! (&D)\x02状态:\x02断开 (&D)\x02连接 (&A)" +
	"\x02公钥:\x02监听端口:\x02MTU:\x02地址:\x02DNS 服务器:\x02预共享密钥:\x02允许的 IP:\x02对端:" +
	"\x02连接保活间隔:\x02上次握手时间:\x02流量:\x02已启用\x02接收 %[1]s, 发送 %[2]s\x02无法确认隧道状态" +
	"\x02无法连接隧道\x02无法断开隧道连接\x02接口: %[1]s\x02节点\x02创建新隧道\x02编辑隧道\x02名称 (&N):" +
	"\x02公钥 (&P):\x02(未知)\x02拦截未经隧道的流量 (kill-switch) (&B)\x02只有一个节点，且该节点允许的 I" +
	"P 中包含 0.0.0.0/0 或 ::/0 时，使用防火墙规则拦截所有未通过隧道的流量 (DHCP 和 NDP 流量除外)。\x02保存 (&" +
	"S)\x02取消\x02配置 (&C):\x02名称无效\x02必须输入名称。\x02隧道名「%[1]s」无效。\x02无法列出现有隧道\x02" +
	"隧道已存在\x02隧道名「%[1]s」已存在。\x02无法创建新的配置\x02写入文件失败\x02文件「%[1]s」已存在。\x0a\x0a" +
	"您确定要覆盖它吗？\x02已连接\x02正在连接\x02已断开\x02正在断开\x02未知\x02日志\x02复制 (&C)\x02全选 (" +
	"&A)\x02导出… (&S)\x02时间\x02日志消息\x02文本文件 (*.txt)|*.txt|所有文件 (*.*)|*.*\x02导出" +
	"日志\x02关于 WireGuard… (&A)\x02隧道错误\x02%[1]s\x0a\x0a更多信息请查看日志。\x02%[1]s (" +
	"已过时)\x02WireGuard 检测错误\x02无法等待 WireGuard 窗口出现: %[1]v\x02WireGuard: 已断开" +
	"\x02状态: 未知\x02地址: 无\x02管理隧道… (&M)\x02从文件导入隧道… (&I)\x02退出 (&E)\x02WireGua" +
	"rd 隧道错误\x02WireGuard: %[1]s\x02状态: %[1]s\x02地址: %[1]s\x02WireGuard 已连接" +
	"\x02隧道「%[1]s」已连接。\x02WireGuard 已断开\x02隧道「%[1]s」已断开连接。\x02发现更新！\x02WireGu" +
	"ard 更新\x02新的 WireGuard 版本发布了。强烈建议您现在安装。\x02隧道\x02编辑 (&E)\x02新建空隧道… (&E)" +
	"\x02新建隧道\x02删除所选隧道\x02导出所有隧道 (ZIP 压缩包)\x02切换连接状态 (&T)\x02导出所有隧道 (ZIP 压缩包" +
	")… (&Z)\x02编辑所选隧道… (&E)\x02删除所选隧道 (&R)\x02无法导入配置: %[1]v\x02无法列出现有隧道: %[1" +
	"]v\x02另一个同名的隧道「%[1]s」已存在\x02无法导入配置: %[1]v\x02导入隧道\x14\x01\x81\x01\x00" +
	"\x00\x1a\x02导入了 %[1]d 个隧道\x14\x02\x80\x01\x000\x02导入了 %[2]d 个隧道中的 %[1]d " +
	"个隧道\x02无法创建隧道\x14\x01\x81\x01\x00\x00\x17\x02删除 %[1]d 个隧道\x14\x01\x81" +
	"\x01\x00\x00,\x02您确定要删除这 %[1]d 个隧道吗？\x02删除隧道「%[1]s」\x02您确定要删除隧道「%[1]s」吗？" +
	"\x02%[1]s此操作无法撤销。\x02无法删除隧道\x02无法删除隧道: %[1]s\x02无法删除隧道\x14\x01\x81\x01" +
	"\x00\x00 \x02无法删除 %[1]d 个隧道。\x02配置文件 (*.zip, *.conf)|*.zip;*.conf|所有文件 (" +
	"*.*)|*.*\x02从文件导入隧道\x02配置文件 (*.zip)|*.zip\x02导出配置文件 (ZIP 压缩包)\x02%[1]s (" +
	"未签名版本，禁用自动更新)\x02退出 WireGuard 时出错\x02无法停止服务: %[1]v。您可能需要在服务管理器中手动停止 Wi" +
	"reGuard 服务。\x02发现新版 WireGuard。强烈建议您现在安装。\x02状态: 等待用户\x02立即更新\x02状态: 等待更新" +
	"服务\x02错误: %[1]v。请重试。\x02状态: 完成！\x02http2: 成帧器 %[1]p: 解码刚写入的帧失败\x02http" +
	"2: 成帧器 %[1]p: 写入了 %[2]v\x02http2: 成帧器 %[1]p: 读取了 %[2]v\x02http2: 解码的 hpa" +
	"ck 字段 %+[1]v"

var zh_TWIndex = []uint32{ // 177 elements
	// Entry 0 - 1F
	0x00000000, 0x00000007, 0x00000037, 0x00000056,
	0x00000066, 0x000000a4, 0x000000e3, 0x00000114,
	0x00000157, 0x000001bc, 0x000001f8, 0x00000205,
	0x0000021e, 0x0000022f, 0x00000240, 0x00000254,
	0x00000268, 0x00000279, 0x00000283, 0x0000028c,
	0x00000299, 0x000002a6, 0x000002b3, 0x000002c0,
	0x000002cf, 0x000002e3, 0x00000305, 0x00000324,
	0x0000033e, 0x00000366, 0x00000374, 0x00000384,
	// Entry 20 - 3F
	0x000003aa, 0x000003c3, 0x000003e2, 0x0000040b,
	0x00000424, 0x00000437, 0x00000453, 0x0000047b,
	0x00000491, 0x000004b0, 0x000004ca, 0x000004f0,
	0x000004fc, 0x0000051e, 0x0000053a, 0x00000557,
	0x0000056f, 0x00000587, 0x0000058b, 0x0000058d,
	0x0000059e, 0x000005b4, 0x00000634, 0x0000063b,
	0x0000064e, 0x00000655, 0x00000667, 0x00000673,
	0x0000067a, 0x00000684, 0x00000688, 0x0000068f,
	// Entry 40 - 5F
	0x0000069d, 0x000006ad, 0x000006bd, 0x000006c7,
	0x000006d8, 0x000006eb, 0x000006f2, 0x000006fc,
	0x0000071e, 0x00000737, 0x0000074a, 0x00000763,
	0x00000772, 0x00000779, 0x00000789, 0x0000079c,
	0x000007a8, 0x000007b4, 0x000007bd, 0x000007f2,
	0x00000893, 0x0000089f, 0x000008a6, 0x000008b2,
	0x000008c2, 0x000008d8, 0x000008fc, 0x00000915,
	0x00000925, 0x00000946, 0x00000965, 0x00000978,
	// Entry 60 - 7F
	0x000009ab, 0x000009b5, 0x000009c5, 0x000009d5,
	0x000009e5, 0x000009ec, 0x000009f3, 0x000009ff,
	0x00000a0b, 0x00000a1a, 0x00000a21, 0x00000a2e,
	0x00000a5d, 0x00000a6d, 0x00000a83, 0x00000a90,
	0x00000abf, 0x00000ad4, 0x00000aec, 0x00000b19,
	0x00000b2f, 0x00000b3f, 0x00000b4c, 0x00000b5e,
	0x00000b76, 0x00000b82, 0x00000b99, 0x00000bab,
	0x00000bba, 0x00000bc9, 0x00000bdd, 0x00000bf8,
	// Entry 80 - 9F
	0x00000c12, 0x00000c36, 0x00000c3d, 0x00000c4e,
	0x00000ca7, 0x00000cae, 0x00000cba, 0x00000cd2,
	0x00000cdf, 0x00000cf2, 0x00000d15, 0x00000d2d,
	0x00000d52, 0x00000d6a, 0x00000d85, 0x00000da1,
	0x00000dbd, 0x00000de7, 0x00000e03, 0x00000e13,
	0x00000e34, 0x00000e67, 0x00000e7a, 0x00000e98,
	0x00000ec8, 0x00000edd, 0x00000f07, 0x00000f2d,
	0x00000f40, 0x00000f5c, 0x00000f6f, 0x00000f93,
	// Entry A0 - BF
	0x00000fd7, 0x00000ff3, 0x00001011, 0x0000102a,
	0x00001060, 0x00001078, 0x000010d9, 0x0000112e,
	0x00001147, 0x00001154, 0x00001170, 0x00001195,
	0x000011ab, 0x000011e4, 0x00001205, 0x00001225,
	0x00001247,
} // Size: 732 bytes

const zh_TWData string = "" + // Size: 4679 bytes
	"\x02錯誤\x02(無參數)：提升權限並安裝管理服務\x02使用方法： %[1]s [\x0a%[2]s]\x02命令列選項\x02無法確定該" +
	"處理程序是否在 WOW64 下執行： %[1]v\x02您必須在此電腦上執行 64 位元版本的 WireGuard。\x02無法開啓目前處理" +
	"程序的權杖： %[1]v\x02WireGuard 可能只能被內建的「%[1]s」群組成員使用。\x02WireGuard 正在執行，但 U" +
	"I 只能從內建的內建的「%[1]s」群組成員的桌面存取。\x02WireGuard 的工作列圖示在 30 秒後並沒有顯示。\x02就是現在" +
	"\x02系統時鐘倒退了！\x14\x01\x81\x01\x00\x00\x0a\x02%[1]d 年\x14\x01\x81\x01\x00" +
	"\x00\x0a\x02%[1]d 天\x14\x01\x81\x01\x00\x00\x0d\x02%[1]d 小時\x14\x01\x81" +
	"\x01\x00\x00\x0d\x02%[1]d 分鐘\x14\x01\x81\x01\x00\x00\x0a\x02%[1]d 秒\x02%" +
	"[1]s 前\x02%[1]d\u00a0B\x02%.2[1]f\u00a0KiB\x02%.2[1]f\u00a0MiB\x02%.2[1]" +
	"f\u00a0GiB\x02%.2[1]f\u00a0TiB\x02%[1]s： %[2]q\x02無效的 IP 位址\x02無效的網路位址首碼" +
	"長度\x02Endpoint 中沒有指定埠號\x02無效的 Endpoint 位址\x02括號中必須包含一個 IPv6 位址\x02無效的 " +
	"MTU\x02無效的埠號\x02無效的 Persistent Keepalive 設定\x02無效的金鑰： %[1]v\x02金鑰必須剛好長 3" +
	"2 bytes\x02數值必須介於 0 到 2^64-1： %[1]v\x02一行中有兩個逗號\x02隧道名稱無效\x02行必須出現在段落中" +
	"\x02設定的項目必須要有一個等號\x02必須要有一個值\x02[Interface] 中有無效選項\x02[Peer] 中有無效選項\x02I" +
	"nterface 中必須要有一把私鑰\x02[未指定]\x02每個 Peer 都必須要有公鑰\x02讀取設定時發生錯誤\x02Interface" +
	" 中的金鑰無效\x02協定版本必須為 1\x02Peer 中的金鑰無效\x02、\x02 \x02關於 WireGuard\x02WireGua" +
	"rd logo 圖片\x02應用程式版本： %[1]s\x0a後端程式（Go 實作）版本： %[2]s\x0aGo 版本： %[3]s\x0a作" +
	"業系統： %[4]s\x0a架構： %[5]s\x02關閉\x02♥ 捐贈！ (&D)\x02狀態\x02中斷連線 (&D)\x02連線 (" +
	"&A)\x02公鑰\x02監聽埠\x02MTU\x02位址\x02DNS 伺服器\x02預交換金鑰\x02允許的位址\x02連接點\x02Kee" +
	"palive 間隔\x02最後交握時間\x02流量\x02已啓用\x02已收到 %[1]s；已傳送 %[2]s\x02無法確認隧道狀態\x02無" +
	"法連接隧道\x02無法斷開隧道連線\x02[隧道] %[1]s\x02節點\x02建立新隧道\x02編輯隧道設定\x02名稱 (&N)" +
	"\x02公鑰 (&P)\x02(未知)\x02阻斷未經過隧道的流量（kill-switch） (&B)\x02只有一個節點且該節點允許位址包含 " +
	"0.0.0.0/0 或 ::/0 時，使用防火牆攔截所有非通過隧道的流量。\x0a（DHCP 及 NDP 流量除外）\x02儲存 (&S)" +
	"\x02取消\x02設定 (&C)\x02無效的名稱\x02必須填寫名稱。\x02無效的隧道名稱「%[1]s」。\x02無法列出現有隧道\x02" +
	"隧道已存在\x02已有同名隧道「%[1]s」。\x02無法建立新的隧道設定\x02檔案寫入失敗\x02檔案已存在： %[1]s\x0a" +
	"\x0a您確定要覆蓋嗎？\x02已連線\x02正在連線…\x02已中斷連線\x02正在中斷…\x02未知\x02日誌\x02複製 (&C)" +
	"\x02全選 (&A)\x02匯出… (&S)\x02時間\x02日誌訊息\x02純文字 (*.txt)|*.txt|所有檔案 (*.*)|*." +
	"*\x02匯出日誌…\x02關於 WireGuard (&A)\x02隧道錯誤\x02%[1]s\x0a\x0a如需更多資訊，請查看日誌。" +
	"\x02%[1]s（已過時）\x02偵測 WireGuard 錯誤\x02無法等待 WireGuard 視窗開啓： %[1]v\x02WireG" +
	"uard - 未連線\x02[狀態] 未知\x02[位址] 無\x02管理隧道 (&M)\x02從檔案匯入… (&I)\x02離開 (&X)" +
	"\x02WireGuard 隧道錯誤\x02WireGuard - %[1]s\x02[狀態] %[1]s\x02[位址] %[1]s\x02W" +
	"ireGuard 已連線\x02已連線至隧道 - %[1]s\x02WireGuard 已中斷連線\x02已中斷與隧道的連線 - %[1]s" +
	"\x02更新\x02WireGuard 更新\x02更新的 WireGuard 已經為您準備好了。\x0a強烈建議您立即更新 WireGuard" +
	"。\x02隧道\x02編輯 (&E)\x02新增隧道精靈 (&E)\x02新增隧道\x02刪除選取隧道\x02匯出所有隧道（ZIP 格式）" +
	"\x02切換連線狀態 (&T)\x02匯出所有隧道至 &ZIP 壓縮檔\x02編輯選取隧道 (&S)\x02刪除已選取隧道 (&R)\x02無法" +
	"匯入設定： %[1]v\x02無法列出隧道： %[1]v\x02已有另一個同名的隧道「%[1]s」\x02無法匯入設定： %[1]v\x02" +
	"已匯入隧道\x14\x01\x81\x01\x00\x00\x1a\x02已匯入 %[1]d 個隧道\x14\x02\x80\x01\x00" +
	"-\x02已匯入 %[1]d 個隧道（共 %[2]d 個）\x02無法建立隧道\x14\x01\x81\x01\x00\x00\x17\x02刪" +
	"除 %[1]d 個隧道\x14\x01\x81\x01\x00\x00)\x02您確定要刪除 %[1]d 個隧道嗎？\x02刪除隧道 - %" +
	"[1]s\x02您確定要刪除隧道「%[1]s」嗎？\x02%[1]s\x0a\x0a您將無法復原此操作。\x02無法刪除隧道\x02無法刪除隧道" +
	"： %[1]s\x02無法刪除隧道\x14\x01\x81\x01\x00\x00\x1d\x02無法刪除 %[1]d 個隧道\x02隧道設" +
	"定檔 (*.zip, *.conf)|*.zip;*.conf|所有檔案 (*.*)|*.*\x02從檔案中匯入隧道…\x02隧道設定檔 (" +
	"*.zip)|*.zip\x02匯出隧道設定至…\x02%[1]s（未簽署發行版本，無法自動更新）\x02離開 WireGuard 失敗\x02" +
	"無法結束服務： %[1]v。\x0a您可能需要手動從服務管理中結束 WireGuard 服務。\x02更新的 WireGuard 已經為您準" +
	"備好了。\x0a強烈建議您立即進行更新。\x02狀態：等待使用者\x02立即更新\x02狀態：等待更新服務\x02錯誤： %[1]v。請稍後" +
	"再試。\x02狀態：已完成！\x02http2: Framer %[1]p: failed to decode just-written f" +
	"rame\x02http2: Framer %[1]p: wrote %[2]v\x02http2: Framer %[1]p: read %[" +
	"2]v\x02http2: decoded hpack field %+[1]v"

	// Total table size 81399 bytes (79KiB); checksum: A775CCDC
